/*
****************************************************************************

            Copyright 1991, by Sun Microsystems, Inc.

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of Sun Microsystems, Inc. or
FUJITSU LIMITED not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior
permission.  FUJITSU LIMITED and Sun Microsystems, Inc. make no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.

SUN MICROSYSTEMS, INC. AND FUJITSU LIMITED DISCLAIMS ALL WARRANTIES
WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL FUJITSU LIMITED AND SUN
MICROSYSTEMS, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CTrueSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTITrue OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTITrue, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

****************************************************************************
*/

#ifndef lint
#ident  "@(#)HttLkupWrap.c	1.15    93/03/16 SMI"
#endif

#ifdef X_LOCALE
#include <X11/Xlocale.h>
#else
#include <locale.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include "XSunExt.h"

#include <X11/Xutil.h>
#include "Htt.h"
extern	htt_t	*htt;
#include "HttLkup.h"
#include "XSunIMProt.h"
#include "HttXsfSun.h"


extern	int	s_lookup_init();
extern	void	s_lookup_start();
extern	void	s_lookup_draw();
extern	void	s_lookup_process();
extern	void	s_lookup_done();
extern	void	s_lookup_reconfigure();
extern	void	s_lookup_redisplay();
extern	void	s_lookup_focusin();
extern	void	s_lookup_focusout();
extern  Bool	s_lookup_keyevent();
extern	void	s_lookup_destroy();
extern	void	s_lookup_end();
extern  int	s_lookup_getval();
extern  int	s_lookup_setval();
/*
extern	int	g_lookup_init();
extern	void	g_lookup_start();
extern	void	g_lookup_draw();
extern	void	g_lookup_process();
extern	void	g_lookup_done();
extern	void	g_lookup_reconfigure();
extern	void	g_lookup_redisplay();
extern	void	g_lookup_focusin();
extern	void	g_lookup_focusout();
extern  Bool	g_lookup_keyevent();
extern	void	g_lookup_destroy();
extern	void	g_lookup_end();
extern  int	g_lookup_getval();
extern  int	g_lookup_setval();
*/



static HttResourceEnums yn_t[] = {
	{"on", 1}, {"On", 1}, {"True", 1}, {"true", 1},
	{"off", 0}, {"Off", 0}, {"False", 0}, {"false", 0}, {0,0}
};
static HttResourceEnums menu_t[] = {
	{"popup", LOOKUP_MENU_POPUPWINDOW}, {"rootwindow", LOOKUP_MENU_IMSWINDOW},
	{"gorgeous", LOOKUP_MENU_GORGEOUS},
	{0,0}
};
static HttResourceEnums nav_t[] = {
	{"mouse", LOOKUP_POSITION_MOUSE}, {"window", LOOKUP_POSITION_WINDOW},
	{0,0}
};
static HttResourceEnums next_t[] = {
	{"left", LOOKUP_NEXT_TO_LEFT}, {"top", LOOKUP_NEXT_TO_TOP},
	{"right", LOOKUP_NEXT_TO_RIGHT}, {"bottom", LOOKUP_NEXT_TO_BOTTOM},
	{0,0}
};
static HttResourceEnums luc_label_t[] = {
	{"none", IM_LUC_LABEL_NONE}, {"alphabetic", IM_LUC_LABEL_ALPHABETIC},
	{"numeric", IM_LUC_LABEL_NUMERIC}, {"alpha_upper", IM_LUC_LABEL_ALPHA_UPPER},
	{0,0}
};

static HttResources luc_resources[] = {
{"lookup.font",		"Lookup.Font",		HttOffset(LucRec, font_name),
		HTT_STR_T,	0, (XPointer)NULL},
{"lookup.style",		"Lookup.Style",		HttOffset(LucRec, style),
		HTT_ENUM_T,	menu_t, (XPointer)LOOKUP_MENU_POPUPWINDOW},
{"lookup.background",	"Lookup.Background",	HttOffset(LucRec, background_color),
		HTT_STR_T,	0, (XPointer)NULL},
{"lookup.foreground",	"Lookup.Foreground",	HttOffset(LucRec, foreground_color),
		HTT_STR_T,	0, (XPointer)NULL},
{"lookup.nrows",		"Lookup.Nrows",		HttOffset(LucRec, nrows),
		HTT_INT_T,	0, (XPointer)5},
{"lookup.ncolumns",	"Lookup.Ncolumns",	HttOffset(LucRec, ncolumns),
		HTT_INT_T,	0, (XPointer)6},
{"lookup.navigation",	"Lookup.Navigation",	HttOffset(LucRec, navigation),
		HTT_ENUM_T,	yn_t, (XPointer)0},
{"lookup.positionNavigator",	"Lookup.PositionNavigator",	HttOffset(LucRec, navigator),
		HTT_ENUM_T,	nav_t, (XPointer)LOOKUP_POSITION_MOUSE},
{"lookup.attachedBorder",	"Lookup.AttachedBorder",	HttOffset(LucRec, next_to),
		HTT_ENUM_T,	next_t, (XPointer)LOOKUP_NEXT_TO_BOTTOM},
{"lookup.offset.x",	"Lookup.Offset.X",	HttOffset(LucRec, off_x),
		HTT_INT_T,	0, (XPointer)10},
{"lookup.offset.y",	"Lookup.Offset.Y",	HttOffset(LucRec, off_y),
		HTT_INT_T,      0, (XPointer)10},
{"lookup.label",	"Lookup.Label",	HttOffset(LucRec, label_type),
		HTT_ENUM_T,    luc_label_t, (XPointer)IM_LUC_LABEL_ALPHABETIC},
{"lookup.movable",	"Lookup.Movable",	HttOffset(LucRec, move),
		HTT_ENUM_T,      yn_t, (XPointer)1},
{"lookup.saveUnder",	"Lookup.SaveUnder",	HttOffset(LucRec, save_under),
		HTT_ENUM_T,      yn_t, (XPointer)1},
{"lookup.borderWidth",	"Lookup.BorderWidth",	HttOffset(LucRec, borderwidth),
		HTT_INT_T,      0, (XPointer)2},
{"lookup.frameTitle",	"Lookup.FrameTitle",	HttOffset(LucRec, title),
		HTT_STR_T,      0, (XPointer)NULL},
{"lookup.titlePosition",	"Lookup.TitlePosition",	HttOffset(LucRec,title_pos),
		HTT_ENUM_T,     next_t, (XPointer)0},
{0,0,0,0,0,0}
} ;


static struct _LookupFuncTable {
    int		(*lookup_init)();
    void	(*lookup_start)();
    void	(*lookup_draw)();
    void	(*lookup_process)();
    void	(*lookup_done)();
    void	(*lookup_reconfigure)();
    void	(*lookup_redisplay)();
    void	(*lookup_focusin)();
    void	(*lookup_focusout)();
    Bool	(*lookup_keyevent)();
    void	(*lookup_destroy)();
    void	(*lookup_end)();
    int		(*lookup_getval)();
    int		(*lookup_setval)();
} lookup_func_table;


SelectLookupChoiceStyle()
{
    LookupInfo	*info ;

    htt->core->lookup_info = (XPointer)shmalloc(sizeof(LookupInfo));

    GetDefaults(luc_resources, htt->core->lookup_info);
    info = (LookupInfo *)GET_HTT_VALUE(htt, lookup_info);

    if(!info->font_name)
	info->font_name = htt->core->font_name;

    if(!info->background_color)
	info->background_color = htt->core->background_color;

    if(!info->foreground_color)
	info->foreground_color = htt->core->foreground_color;

    switch(info->style) {
	case LOOKUP_MENU_POPUPWINDOW:
	case LOOKUP_MENU_IMSWINDOW:
	case LOOKUP_MENU_IMSWINDOW2:
	    lookup_func_table.lookup_init = s_lookup_init;
	    lookup_func_table.lookup_start = s_lookup_start;
	    lookup_func_table.lookup_draw = s_lookup_draw;
	    lookup_func_table.lookup_process = s_lookup_process;
	    lookup_func_table.lookup_done = s_lookup_done;
	    lookup_func_table.lookup_reconfigure = s_lookup_reconfigure;
	    lookup_func_table.lookup_redisplay = s_lookup_redisplay;
	    lookup_func_table.lookup_focusin = s_lookup_focusin;
	    lookup_func_table.lookup_focusout = s_lookup_focusout;
	    lookup_func_table.lookup_keyevent = s_lookup_keyevent;
	    lookup_func_table.lookup_destroy = s_lookup_destroy;
	    lookup_func_table.lookup_end = s_lookup_end;
	    lookup_func_table.lookup_getval = s_lookup_getval;
	    lookup_func_table.lookup_setval = s_lookup_setval;
	    break;
	case LOOKUP_MENU_GORGEOUS:
	    break;
	default:
	    break;
    }
}

int
LookupChoiceInit()
{
    int		ret;

    ret = (*lookup_func_table.lookup_init)(htt);
    return (ret);
}

void
lookup_start_server( ic, rv )
    FXimp_Client	*ic ;
    iml_inst		*rv ;
{
    (*lookup_func_table.lookup_start)(ic, rv);
}

void
lookup_draw_server( ic, rv )
    FXimp_Client	*ic ;
    iml_inst		*rv ;
{
    (*lookup_func_table.lookup_draw)(ic, rv);
}

extern void
Lkup_Redisplay(evp, ic)
    XEvent		*evp;
    FXimp_Client	*ic ;
{
    (*lookup_func_table.lookup_redisplay)(evp, ic);
}

extern void
Lkup_Reconfigure(ic, evp)
    FXimp_Client	*ic ;
    XEvent		*evp;
{
    (*lookup_func_table.lookup_reconfigure)(ic, evp);
}

void
lookup_process_server( ic, rv )
    FXimp_Client	*ic ;
    iml_inst		*rv ;
{
    (*lookup_func_table.lookup_process)(ic, rv);
}


void
lookup_done_server( ic )
    FXimp_Client	*ic ;
{
    (*lookup_func_table.lookup_done)(ic);
}


extern void
Lkup_FocusIn( ic )
    FXimp_Client	*ic;
{
    (*lookup_func_table.lookup_focusin)(ic);
}

extern void
Lkup_FocusOut( ic )
    FXimp_Client	*ic;
{
    (*lookup_func_table.lookup_focusout)(ic);
}

void
Lkup_End( ic )
    FXimp_Client	*ic ;
{
    (*lookup_func_table.lookup_end)(ic);
}

void
DestroyLookupWindow( ic )
    FXimp_Client	*ic ;
{
    (*lookup_func_table.lookup_destroy)(ic);
}

Bool
LucNeedsThisKeyEvent(ev, htt)
    XEvent	*ev;
    htt_t	*htt;
{
    return (*lookup_func_table.lookup_keyevent)(ev, htt);
}

int
GetLUCValue(htt, attr, val)
    htt_t	*htt;
    char	*attr;
    void	*val;
{
    return (*lookup_func_table.lookup_getval)(htt, attr, val);
}

int
SetLUCValue(htt, attr, val)
    htt_t	*htt;
    char	*attr;
    void	*val;
{
    return (*lookup_func_table.lookup_setval)(htt, attr, val);
}
