/*****************************************************************************

            Copyright 1991, by FUJITSU LIMITED
            Copyright 1991, by Sun Microsystems, Inc.

Permission to use, copy, modify, distribute, and sell this software
and its documentation for any purpose is hereby granted without fee,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of FUJITSU LIMITED or Sun
Microsystems, Inc.  not be used in advertising or publicity pertaining
to distribution of the software without specific, written prior
permission.  FUJITSU LIMITED and Sun Microsystems, Inc. make no
representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.

FUJITSU LIMITED AND SUN MICROSYSTEMS, INC. DISCLAIMS ALL WARRANTIES
ITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF
MERCHANTABILITY AND FITNESS, IN NO EVENT SHALL FUJITSU LIMITED AND SUN
MICROSYSTEMS, INC. BE LIABLE FOR ANY SPECIAL, INDIRECT OR
CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF
USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.

Auther: Takashi Fujiwara		FUJITSU LIMITED
		fujiwara@a80.tech.yk.fujitsu.co.jp
	Kiyoaki oya			FUJITSU LIMITED
	Riki	Kawaguchi		FUJITSU LIMITED
	Tomoki	Kuriki			FUJITSU LIMITED
        Hideki Hiura (hhiura@Sun.COM) 	Sun Microsystems, Inc.

****************************************************************************
*/

#ifndef lint
#ident  "@(#)HttXimp.c	1.79    93/03/23 SMI"
static char     derived_from_sccs_id[] = "Ximp.c	2.1 91/08/13 11:28:42 FUJITSU LIMITED.";
#endif

#include <stdio.h>

#include <X11/Xlib.h>
#if XlibSpecificationRelease != 5
#include <X11/XlibR5.h>
#endif /* XlibSpecificationRelease */
#include "XSunExt.h"
#include <X11/keysym.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>
#ifdef X_LOCALE
#include <X11/Xlocale.h>
#else
#include <locale.h>
#endif
#include <signal.h>
#include "HttTransTbl.h"

#include "Htt.h"
#include "HttLkup.h"

#define MARS 

extern htt_t	*htt;
extern int	client_is_cmsg_only;

extern FXimp_Client   *FindAnyActiveClient();
extern void		CreateWindows();
Atom 			XimpAtomPool();

Private	void		XimpClientMessage_35();
Private	void		XimpClientMessage_40();
Private	void		Ximp_check_version();
Private	void		Ximp_send_compound_text();
Private	void		Ximp_preeditdraw_cm();
Private	void		Ximp_preeditdraw_tiny();
Private	void		Ximp_preeditdraw_feedback();
Private unsigned long	DropStatusXICMask();
Private unsigned long	DropPreeditXICMask();

#define  XIMP_E_MAX_USER	101
#define  XIMP_TIME_OUT		5

#define SunXK_Hangul            0xFF31

Private char *supported_locales[] = {

    "japanese", "ja", "ja_JP",
    "korean", "ko",
    "chinese", "zh",
    "tchinese", "zh_TW",
    (char *) NULL

} ;

XIMStyle2	style2[] = {
    XIMP_BE_TYPE1,
    XIMP_FE_TYPE1,
    XIMP_BE_TYPE2,
    XIMP_FE_TYPE2,
    XIMP_FE_TYPE3,
    XIMP_SYNC_BE_TYPE1,
    XIMP_SYNC_BE_TYPE2,
};
#define  MAX_STYLE2		sizeof( style2 ) / sizeof( style2[0] )

unsigned long   Start_key[] =
{0x00000000, (ControlMask | ShiftMask), XK_Henkan_Mode,
    0x00000000, (ControlMask | ShiftMask), SunXK_Hangul,
    ControlMask, (ControlMask | ShiftMask), XK_space,	/* CTRL space */
    ControlMask, (ControlMask | ShiftMask), XK_at,	/* CTRL @ for Japanese KBD */
    (ControlMask|ShiftMask), (ControlMask | ShiftMask), XK_at,	/* CTRL @ for Domestic KBD */
};
#define  START_MAX_KEY		sizeof( Start_key ) / sizeof( Start_key[0] )

unsigned long   Stop_key[] =
{0x00000000, (ControlMask | ShiftMask), XK_Henkan_Mode,
    0x00000000, (ControlMask | ShiftMask), SunXK_Hangul,
    ControlMask, (ControlMask | ShiftMask), XK_space,	/* CTRL space */
    ControlMask, (ControlMask | ShiftMask), XK_at,	/* CTRL @ for Japanese KBD */
    (ControlMask|ShiftMask), (ControlMask | ShiftMask), XK_at,	/* CTRL @ for Domestic KBD */
};
#define  STOP_MAX_KEY		sizeof( Stop_key ) / sizeof( Stop_key[0] )

/*
Public  Atom            IMA_IMPROTOCOL;
*/

Private Atom            IMA_VERSION, IMA_FOCUS;
Private Atom            IMA_PREEDIT, IMA_PREEDITFONT;
Private Atom            IMA_STATUS, IMA_STATUSFONT;
Private Atom            IMA_CTEXT, IMA_COMPOUND_TEXT;
Private Atom            IMA_EXT_SAMPLE_STATUSWINDOW;
Private Atom            IMA_EXT_SAMPLE_BACK_FRONT;
Private Atom            IMA_PREEDIT_DRAW_DATA;
Private Atom            IMA_FEEDBACKS;
#ifdef notdef 
Private Atom            IMA_EXT_XIMP_LOOKUPCHOICES;
Private Atom            IMA_EXT_XIMP_CHOICE_START_REQ;
Private Atom            IMA_EXT_XIMP_CHOICE_START_REP;
Private Atom            IMA_EXT_XIMP_CHOICE_DRAW_REQ;
Private Atom            IMA_EXT_XIMP_CHOICE_PROC_REQ;
Private Atom            IMA_EXT_XIMP_CHOICE_PROC_REP;
#endif
Private Atom            IMA_EXT_XIMP_CONVERSION;
Private Atom            XA_COMPOUND_TEXT;
Private Atom		IMA_TYPE;

Private FXimp_ICID icid;


int
IsMode(keysym, mod)
    KeySym          keysym;
    unsigned int    mod;
{
    int             i;

    for (i = 0; i < START_MAX_KEY; i = i + 3)
	if ( ( mod & Start_key[i + 1] ) == Start_key[i]
	    && keysym == Start_key[i + 2] )
	    return (1);
    return (0);
}

CreateXimpAtom()
{
#define EXTENSIONS_LIST_SIZE	3
    Display        *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);
    Window	   root = GET_HTT_VALUE(htt, root);
    int		   screen = GET_HTT_VALUE(htt, screen);
    unsigned char  *server_name = GET_HTT_VALUE(htt, server_name);
    unsigned char  *server_version = GET_HTT_VALUE(htt, server_version);
    unsigned char  *vendor_name = GET_HTT_VALUE(htt, vendor_name);

    Atom     extensions_list[EXTENSIONS_LIST_SIZE];
    Window   imserver_window = root_client->window;
    Atom     id;
    Atom     type;
    Atom     selection_sub_atom;
    Atom     selection_atom, selection_atom_long;
    long     ext_ui_back_front;
    long     ext_ui_conversion;
    char     im_name[16];
    char     im_lname[32] ;
    register i ;
    register conflict = 0  ;
    char    *ims_org_locale = setlocale(LC_CTYPE, NULL);
    Atom     ims_org_locale_atom = 0 ;

#ifdef MULTIPLEIMNAME
    for(i=0, conflict=0 ;supported_locales[i]; i++){
	sprintf(im_name, "%s%s", _XIMP_BASE, supported_locales[i]);
	sprintf(im_lname, "%s@%s.%d", im_name, server_name, screen);
	if (selection_atom = XInternAtom(display, im_lname, True)) {
	    if (XGetSelectionOwner(display, selection_atom)) {
		WarningMessage(002);
		conflict++ ;
		continue ;
	    }
	} else {
	    selection_atom = XInternAtom(display, im_lname, False);
	}
	XSetSelectionOwner(display, selection_atom, imserver_window, 0L);
	if (!ims_org_locale_atom && !strcmp(supported_locales[i], ims_org_locale)){
	    ims_org_locale_atom = selection_sub_atom ;
	}
#ifdef DEBUG
	XChangeProperty(display, root, selection_atom, XA_STRING, 8,
			PropModeReplace, server_name, strlen(server_name));
#endif				/* DEBUG */

	if (selection_atom = XInternAtom(display, im_name, True)) {
	    if (XGetSelectionOwner(display, selection_atom)) {
		WarningMessage(002);
		continue;
	    }
	} else {
	    selection_atom = XInternAtom(display, im_name, False);
	}
	XSetSelectionOwner(display, selection_sub_atom, imserver_window, 0L);
#ifdef DEBUG
	XChangeProperty(display, root, selection_atom, XA_STRING, 8,
			PropModeReplace, server_name, strlen(server_name));
#endif				/* DEBUG */

    }
    /*
     * HACK HACK HACK To make sure
     */
    XSetSelectionOwner(display, ims_org_locale_atom, imserver_window, 0L);
    if(conflict >= (i-1)){
	ErrorMessage(002);
	exit (1);
    }

#else /* MULTIPLEIMNAME */
        if (!strncmp(ims_org_locale, "japanese", 2)) {
            strcpy(ims_org_locale, "ja_JP");
        } else if (!strncmp(ims_org_locale, "korean", 2)) {
            strcpy(ims_org_locale, "ko_KR");
        } else if (!strcmp(ims_org_locale, "chinese") || !strcmp(ims_org_locale, "zh")) {
            strcpy(ims_org_locale, "zh_CN");
        } else if (!strcmp(ims_org_locale, "tchinese") || !strcmp(ims_org_locale, "zh_TW")) {
            strcpy(ims_org_locale, "zh_TW");
        }

    sprintf(im_name, "%s%s", _XIMP_BASE, ims_org_locale);
    sprintf(im_lname, "%s@%s.%d", im_name, server_name, screen);
    if (selection_atom = XInternAtom(display, im_name, True)) {
	if (XGetSelectionOwner(display, selection_atom)) {
	    conflict++ ;
	}
    } else {
	selection_atom = XInternAtom(display, im_name, False);
    }
    if (!conflict) {
        XSetSelectionOwner(display, selection_atom, imserver_window, 0L);
    	XChangeProperty(display, root, selection_atom, XA_STRING, 8,
		    PropModeReplace, "Htt.1.0.1", strlen("Htt.1.0.1"));
    }

    if (selection_atom_long = XInternAtom(display, im_lname, True)) {
	if (XGetSelectionOwner(display, selection_atom_long)) {
	    ErrorMessage(002);
	    exit(1);
	}
    } else {
	selection_atom_long = XInternAtom(display, im_lname, False);
    }
    XSetSelectionOwner(display, selection_atom_long, imserver_window, 0L);

    XChangeProperty(display, root, selection_atom_long, XA_STRING, 8,
		    PropModeReplace, "Htt.1.0.1", strlen("Htt.1.0.1"));


#endif /* MULTIPLEIMNAME */


    id = XInternAtom(display, _XIMP_VERSION, False);
    IMA_VERSION = id;
    XChangeProperty(display, imserver_window, id, XA_STRING, 8, PropModeReplace,
    (unsigned char *) XIMP_PROTOCOL_VERSION, strlen(XIMP_PROTOCOL_VERSION));

    type = XInternAtom(display, _XIMP_STYLE, False);
    id = type;
    XChangeProperty(display, imserver_window, id, type, 32, PropModeReplace,
		    (unsigned char *) htt->core->styles, htt->core->nstyles);

    type = XInternAtom(display, _XIMP_KEYS, False);
    id = type;
    XChangeProperty(display, imserver_window, id, type, 32, PropModeReplace,
		    (unsigned char *) Start_key, START_MAX_KEY);

    type = XInternAtom(display, _XIMP_SPROC_STARTED_KEYS, False);
    id = type;
    XChangeProperty(display, imserver_window, id, type, 32, PropModeReplace,
		    (unsigned char *) Start_key, START_MAX_KEY);

    type = XInternAtom(display, _XIMP_SPROC_STOPPED_KEYS, False);
    id = type;
    XChangeProperty(display, imserver_window, id, type, 32, PropModeReplace,
		    (unsigned char *) Stop_key, STOP_MAX_KEY);

    id = XInternAtom(display, _XIMP_SERVERNAME, False);
    type = XA_STRING;
    XChangeProperty(display, imserver_window, id, type, 8, PropModeReplace,
		    server_name, strlen(server_name));

    id = XInternAtom(display, _XIMP_SERVERVERSION, False);
    type = XA_STRING;
    XChangeProperty(display, imserver_window, id, type, 8, PropModeReplace,
		    server_version, strlen(server_version));

    id = XInternAtom(display, _XIMP_VENDORNAME, False);
    type = XA_STRING;
    XChangeProperty(display, imserver_window, id, type, 8, PropModeReplace,
		    vendor_name, strlen(vendor_name));

    type = XInternAtom(display, _XIMP_TYPE, False);
    id = type;
    XChangeProperty(display, imserver_window, id, type, 32, PropModeReplace,
		    (unsigned char *) style2, MAX_STYLE2);
    IMA_TYPE = type;
    SET_HTT_VALUE(htt, IMA_IMPROTOCOL, XInternAtom(display, _XIMP_PROTOCOL, False));
/*
    IMA_IMPROTOCOL = XInternAtom(display, _XIMP_PROTOCOL, False);
*/
    IMA_FOCUS = XInternAtom(display, _XIMP_FOCUS, False);
    IMA_PREEDIT = XInternAtom(display, _XIMP_PREEDIT, False);
    IMA_STATUS = XInternAtom(display, _XIMP_STATUS, False);
    IMA_PREEDITFONT = XInternAtom(display, _XIMP_PREEDITFONT, False);
    IMA_STATUSFONT = XInternAtom(display, _XIMP_STATUSFONT, False);
    IMA_CTEXT = XInternAtom(display, _XIMP_CTEXT, False);
    IMA_COMPOUND_TEXT = XInternAtom(display, "COMPOUND_TEXT", False);
    IMA_EXT_SAMPLE_STATUSWINDOW
	= XInternAtom(display, "_XIMP_EXT_XIMP_STATUSWINDOW", False);
    IMA_EXT_SAMPLE_BACK_FRONT
	= XInternAtom(display, "_XIMP_EXT_XIMP_BACK_FRONT", False);
    IMA_EXT_XIMP_CONVERSION
	= XInternAtom(display, "_XIMP_EXT_XIMP_CONVERSION", False);
    IMA_PREEDIT_DRAW_DATA = XInternAtom(display, _XIMP_PREEDIT_DRAW_DATA, False);
    IMA_FEEDBACKS = XInternAtom(display, _XIMP_FEEDBACKS, False);
#ifdef notdef
    IMA_EXT_XIMP_LOOKUPCHOICES = XInternAtom(display, _XIMP_EXT_XIMP_LOOKUPCHOICES, False);
    IMA_EXT_XIMP_CHOICE_START_REQ = XInternAtom(display, _XIMP_EXT_XIMP_CHOICE_START_REQ, False);
    IMA_EXT_XIMP_CHOICE_START_REP = XInternAtom(display, _XIMP_EXT_XIMP_CHOICE_START_REP, False);
    IMA_EXT_XIMP_CHOICE_DRAW_REQ = XInternAtom(display, _XIMP_EXT_XIMP_CHOICE_DRAW_REQ,
					       False);
    IMA_EXT_XIMP_CHOICE_PROC_REQ = XInternAtom(display, _XIMP_EXT_XIMP_CHOICE_PROC_REQ, False);
    IMA_EXT_XIMP_CHOICE_PROC_REP = XInternAtom(display, _XIMP_EXT_XIMP_CHOICE_PROC_REP, False);
#endif
    XA_COMPOUND_TEXT = XInternAtom(display, "XA_COMPOUND_TEXT", False);

    id = IMA_EXT_SAMPLE_BACK_FRONT;
    type = id;
    ext_ui_back_front = 0;
    XChangeProperty(display, imserver_window, id, type, 32, PropModeReplace,
		    (unsigned char *) &ext_ui_back_front, 1);

    id = IMA_EXT_XIMP_CONVERSION;
    type = id;
    ext_ui_conversion = False;
    XChangeProperty(display, imserver_window, id, type, 32, PropModeReplace,
		    (unsigned char *) &ext_ui_conversion, 1);

    extensions_list[0] = IMA_EXT_SAMPLE_BACK_FRONT;
    extensions_list[1] = IMA_EXT_SAMPLE_STATUSWINDOW;
    extensions_list[2] = IMA_EXT_XIMP_CONVERSION;
#ifdef notdef
    extensions_list[3] = IMA_EXT_XIMP_LOOKUPCHOICES;
#endif
    id = XInternAtom(display, _XIMP_EXTENSIONS, False);
    type = id;
    XChangeProperty(display, imserver_window, id, type, 32, PropModeReplace,
		    (unsigned char *) extensions_list, EXTENSIONS_LIST_SIZE);
}
shmem_update_notify()
{
    shmem_misc_update_notify();
    shmem_luc_update_notify();
#ifdef notyet
    shmem_root_update_notify();
#endif
}
shmem_misc_update_notify(even)
{
    Display        *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);
    Window	   root = GET_HTT_VALUE(htt, root);
    int		   screen = GET_HTT_VALUE(htt, screen);
    Window   imserver_window = root_client->window;
    Atom     id;
    Atom     type;

    type = XInternAtom(display, _XIMP_STYLE, False);
    id = type;
    XChangeProperty(display, imserver_window, id, type, 32, PropModeReplace,
		    (unsigned char *) htt->core->styles, htt->core->nstyles);
    XFlush(display);
}

shmem_luc_update_notify()
{
    FXimp_Client	*accl;     /* Active IC if there is any */
    LookupInfo *lucinfo = (LookupInfo *)GET_HTT_VALUE(htt, lookup_info);
    LayoutInfo layout;
    Bool	head = True;

    if(lucinfo->lock)
	return;

    SetLUCValue(htt, LUC_LOOKUP_INFO, lucinfo);
    GetLUCValue(htt, LUC_LAYOUT, &layout);

    while(accl = FindAnyActiveClient(head)) {
	if_SetSCValue(accl->s, SC_lookup_nchoices, layout.choice_per_window);
	if(lucinfo->style == LOOKUP_MENU_IMSWINDOW) {
	    if_SetSCValue(accl->s, SC_lookup_root,  True);
	    if_SetSCValue(accl->s, SC_lookup_rootwidth, layout.root_width);
            if_SetSCValue(accl->s, SC_lookup_lines, layout.root_lines);
            if_SetSCValue(accl->s, SC_lookup_ewidth, layout.e_width_per_can);
            if_SetSCValue(accl->s, SC_lookup_cwidth, layout.max_width_per_car);
	}
	else
	    if_SetSCValue(accl->s, SC_lookup_root,  False);
	if_SetSCValue(accl->s, SC_lookup_ncols, layout.ncolumns);
	if_SetSCValue(accl->s, SC_lookup_nrows, layout.nrows);
	if_SetSCValue(accl->s, SC_nego_flush, True);
	head = False;
   }
}

XimpClientMessage(event)
    XEvent         *event;
{
    FXimp_Client   *ximp_client;
    switch (event->xclient.data.l[0]) {
    case XIMP_CREATE:
	XimpCreate_40(event);
	break;
    case XIMP_CREATE_BC:
	XimpCreate_35(event);
	break;
/* Using between Property sheet and slave processes */
    case XIMP_EXT_SHMEM_UPDATE_NOTIFY:
	shmem_update_notify();
	break;

    case XIMP_EVENTMASK_NOTIFY4:
    case XIMP_KEYRELEASE4:
    case XIMP_KEYPRESS:
    case XIMP_KEYPRESS_BC:
    case XIMP_DESTROY:
    case XIMP_DESTROY_BC:
    case XIMP_REG_KEY_PRESSED:
    case XIMP_BEGIN_BC:
    case XIMP_END_BC:
    case XIMP_SETFOCUS:
    case XIMP_SETFOCUS_BC:
    case XIMP_UNSETFOCUS:
    case XIMP_UNSETFOCUS_BC:
    case XIMP_CLIENT_WINDOW:
    case XIMP_FOCUS_WINDOW:
    case XIMP_MOVE:
    case XIMP_MOVE_BC:
    case XIMP_RESET:
    case XIMP_RESET_BC:
    case XIMP_SETVALUE:
    case XIMP_SETVALUE_BC:
    case XIMP_GETVALUE:
    case XIMP_GETVALUE_BC:
    case XIMP_EXTENSION:
    case XIMP_EXTENSION_BC:
    case XIMP_PREEDITSTART_RETURN:
    case XIMP_PREEDITSTART_RETURN_BC:
    case XIMP_PREEDITCARET_RETURN:
    case XIMP_PREEDITCARET_RETURN_BC:
    {
	    icid = (FXimp_ICID) event->xclient.data.l[1];
	    ximp_client = FindClientByICID(icid);
	    if (!ximp_client) {
		int             errno = 0;
		switch (event->xclient.data.l[0]) {
		case XIMP_KEYPRESS:
		case XIMP_KEYPRESS_BC:
		    errno = 185;
		    break;
		case XIMP_DESTROY:
		case XIMP_DESTROY_BC:
		    errno = 111;
		    break;
		case XIMP_REG_KEY_PRESSED:
		case XIMP_BEGIN_BC:
		    errno = 121;
		    break;
		case XIMP_END_BC:
		    errno = 131;
		    break;
		case XIMP_SETFOCUS:
		case XIMP_SETFOCUS_BC:
		    errno = 141;
		    break;
		case XIMP_UNSETFOCUS:
		case XIMP_UNSETFOCUS_BC:
		    errno = 151;
		    break;
		case XIMP_CLIENT_WINDOW:
		    errno = 192;
		    break;
		case XIMP_FOCUS_WINDOW:
		    errno = 193;
		    break;
		case XIMP_MOVE:
		case XIMP_MOVE_BC:
		    errno = 161;
		    break;
		case XIMP_RESET:
		case XIMP_RESET_BC:
		    errno = 181;
		    break;
		case XIMP_SETVALUE:
		case XIMP_SETVALUE_BC:
		    errno = 186;
		    break;
		case XIMP_GETVALUE:
		case XIMP_GETVALUE_BC:
		    errno = 187;
		    break;
		case XIMP_EXTENSION:
		case XIMP_EXTENSION_BC:
		    errno = 190;
		    break;
		case XIMP_PREEDITSTART_RETURN:
		case XIMP_PREEDITSTART_RETURN_BC:
		    errno = 171;
		    break;
		case XIMP_PREEDITCARET_RETURN:
		case XIMP_PREEDITCARET_RETURN_BC:
		    errno = 172;
		    break;
		}
		ErrorMessage(errno);
		return (-1);
	    }
	    SET_HTT_VALUE(htt, current_client, ximp_client);
	    switch ( CURRENT_CLIENT(htt)->ximp_version ) {
	    case XIMP_PROTO_35_GRP:
		XimpClientMessage_35( event );
		break;
	    case XIMP_PROTO_40_GRP:
		XimpClientMessage_40( event );
		break;
	    }
	    break;
	}

    default:
	ErrorMessage(100);
	icid = (FXimp_ICID) event->xclient.data.l[1];
	ximp_client = FindClientByICID(icid);
	if (!ximp_client)
	    XimpSendErrorEvent(ximp_client->focus_window, 0,
			       event->xclient.serial, XIMP_BadProtocol, 0);
	break;
    }
    return (0);
}

static void
XimpClientMessage_35(event)
    XEvent         *event;
{
    FXimp_Client   *ximp_client;

    switch (event->xclient.data.l[0]) {
    case XIMP_KEYPRESS:
    case XIMP_DESTROY:
    case XIMP_REG_KEY_PRESSED:
    case XIMP_SETFOCUS:
    case XIMP_UNSETFOCUS:
    case XIMP_CLIENT_WINDOW:
    case XIMP_FOCUS_WINDOW:
    case XIMP_MOVE:
    case XIMP_RESET:
    case XIMP_SETVALUE:
    case XIMP_GETVALUE:
    case XIMP_EXTENSION:
    case XIMP_PREEDITSTART_RETURN:
    case XIMP_PREEDITCARET_RETURN:
	ErrorMessage(100);
	XimpSendErrorEvent(CURRENT_CLIENT(htt)->focus_window, 0,
			       event->xclient.serial, XIMP_BadProtocol, 0);
	break;
    case XIMP_KEYPRESS_BC:
	XimpKeypress(event);
	break;
    case XIMP_DESTROY_BC:
	XimpDestroy(event);
	break;
    case XIMP_BEGIN_BC:
	XimpBegin(event);
	break;
    case XIMP_END_BC:
	XimpEnd(event);
	break;
    case XIMP_SETFOCUS_BC:
	XimpSetfocus(event);
	break;
    case XIMP_UNSETFOCUS_BC:
	XimpUnsetfocus(event);
	break;
    case XIMP_MOVE_BC:
	XimpMove(event);
	break;
    case XIMP_RESET_BC:
	XimpReset(event);
	break;
    case XIMP_SETVALUE_BC:
	XimpSetvalue(event);
	break;
    case XIMP_GETVALUE_BC:
	XimpGetvalue(event);
	break;
    case XIMP_EXTENSION_BC:
	XimpExtension(event);
	break;
    case XIMP_PREEDITSTART_RETURN_BC:
	XimpPreeditStartRet(event);
	break;
    case XIMP_PREEDITCARET_RETURN_BC:
	XimpPreeditCaretRet(event);
	break;
    }
    return;
}

static void
XimpClientMessage_40(event)
    XEvent         *event;
{
    FXimp_Client   *ximp_client;

    switch (event->xclient.data.l[0]) {
    case XIMP_KEYPRESS_BC:
    case XIMP_DESTROY_BC:
    case XIMP_BEGIN_BC:
    case XIMP_END_BC:
    case XIMP_SETFOCUS_BC:
    case XIMP_UNSETFOCUS_BC:
    case XIMP_MOVE_BC:
    case XIMP_RESET_BC:
    case XIMP_SETVALUE_BC:
    case XIMP_GETVALUE_BC:
    case XIMP_EXTENSION_BC:
    case XIMP_PREEDITSTART_RETURN_BC:
    case XIMP_PREEDITCARET_RETURN_BC:
	ErrorMessage(100);
	XimpSendErrorEvent(CURRENT_CLIENT(htt)->focus_window, 0,
			       event->xclient.serial, XIMP_BadProtocol, 0);
	break;
    case XIMP_EVENTMASK_NOTIFY4:
	XimpEventmaskNotify(event);
	break;
    case XIMP_KEYRELEASE4:
	XimpKeyrelease(event);
	break;
    case XIMP_KEYPRESS:
	XimpKeypress(event);
	break;
    case XIMP_DESTROY:
	XimpDestroy(event);
	break;
    case XIMP_REG_KEY_PRESSED:
	XimpBegin(event);
	break;
    case XIMP_SETFOCUS:
	XimpSetfocus(event);
	break;
    case XIMP_UNSETFOCUS:
	XimpUnsetfocus(event);
	break;
    case XIMP_MOVE:
	XimpMove(event);
	break;
    case XIMP_CLIENT_WINDOW:
	XimpClientWindow(event);
	break;
    case XIMP_FOCUS_WINDOW:
	XimpFocusWindow(event);
	break;
    case XIMP_RESET:
	XimpReset(event);
	break;
    case XIMP_SETVALUE:
	XimpSetvalue(event);
	break;
    case XIMP_GETVALUE:
	XimpGetvalue(event);
	break;
    case XIMP_EXTENSION:
	XimpExtension(event);
	break;
    case XIMP_PREEDITSTART_RETURN:
	XimpPreeditStartRet(event);
	break;
    case XIMP_PREEDITCARET_RETURN:
	XimpPreeditCaretRet(event);
	break;
    }
    return;
}

Static int
XimpCreate_35(event)
    XEvent         *event;
{
    Display	   *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);
    LookupInfo     *lookup_info = (LookupInfo *)GET_HTT_VALUE(htt, lookup_info);

    Window          window = event->xclient.data.l[1];
    XIMStyle        inputStyle = event->xclient.data.l[2];
    unsigned long   mask = event->xclient.data.l[3];
    FXimp_Client   *ximp_client;
    char           *GetXimpSubProperty();
    Window         *focus_window;
    int             rc;
    char           *ximp_version, prop_name[32];
    Ximp_StatusPropRec status, *current_status;
    Ximp_PreeditPropRec preedit, *current_preedit;
    LayoutInfo	   luclayout;

    if (inputStyle == 0) {
	ErrorMessage(101);
	XimpSendErrorEvent(window, 0, event->xclient.serial, XIMP_BadStyle, 0);
	return (-1);
    }
    ximp_client = NewClient(window);
    if (!ximp_client) {
	ErrorMessage(103);
	XimpSendErrorEvent(window, 0, event->xclient.serial,
			   XIMP_BadAlloc, XIMP_E_MAX_USER);
	return (-1);
    }
        if(inputStyle & XIMPreeditNothing || inputStyle & XIMStatusNothing)
                XMapRaised(display, root_client->window);
    SET_HTT_VALUE(htt, current_client, ximp_client);
    CURRENT_CLIENT(htt)->prot_type = FPRT_XIM;
    CURRENT_CLIENT(htt)->imp_mode = FIMP_CREATE;
    Fj_InitialMode();
    CURRENT_CLIENT(htt)->style = inputStyle;

    ximp_version = GetXimpSubProperty(window, IMA_VERSION, XA_STRING);
    Ximp_check_version( ximp_version );
    if (mask & XIMP_FOCUS_WIN_MASK_BC) {
	focus_window = (Window *) GetXimpSubProperty(window,
						     IMA_FOCUS, XA_WINDOW);
	if (focus_window) {
	    CURRENT_CLIENT(htt)->focus_window = *focus_window;
	    XFree((char *) focus_window);
	} else {
	    ErrorMessage(108, _XIMP_FOCUS);
	    XimpSendErrorEvent(CURRENT_CLIENT(htt)->focus_window, 0,
			     event->xclient.serial, XIMP_BadFocusWindow, 0);
	    DeleteClient(CURRENT_CLIENT(htt));
	    return (-1);
	}
    } else {
	ErrorMessage(108, _XIMP_FOCUS);
	XimpSendErrorEvent(CURRENT_CLIENT(htt)->focus_window, 0,
			   event->xclient.serial, XIMP_BadFocusWindow, 0);
	DeleteClient(CURRENT_CLIENT(htt));
	return (-1);
    }

    EntryFocusWindow( CURRENT_CLIENT(htt), CURRENT_CLIENT(htt)->focus_window );

    current_preedit = CURRENT_CLIENT(htt)->preedit;
    *current_preedit = *root_client->preedit;
    if ( CURRENT_CLIENT(htt)->style
	& ( XIMPreeditPosition | XIMPreeditNothing | XIMPreeditArea ) ) {
	if ( mask & XSF_PRE_MASK_BC ) {
	    rc = GetPreeditPropRec(window, current_preedit, mask);
	    if (rc != 0) {
		GetPropErrorSendEvent(rc, CURRENT_CLIENT(htt)->focus_window,
				      0, event->xclient.serial);
		goto error_imp_create_35;
	    }
	} else {
	    CURRENT_CLIENT(htt)->window_type |= FC_SAME_ROOT_PREEDIT_GC;
	}

	if (mask & XIMP_PRE_FONT_MASK_BC) {
	    CURRENT_CLIENT(htt)->preedit_fontname =
		GetXimpSubProperty(window, IMA_PREEDITFONT, XA_STRING);
	    CURRENT_CLIENT(htt)->window_type &= ~FC_SAME_ROOT_PREEDIT_GC;
	} else
	    CURRENT_CLIENT(htt)->window_type |= FC_SAME_ROOT_PREEDIT_FONT;
    }
    current_status = CURRENT_CLIENT(htt)->status;
    *current_status = *root_client->status;
    if (CURRENT_CLIENT(htt)->style & (XIMStatusArea | XIMStatusNothing)) {
	if ( mask & XSF_STS_MASK_BC ) {
	    rc = GetStatusPropRec(window, current_status, mask);
	    if (rc != 0) {
		GetPropErrorSendEvent(rc, CURRENT_CLIENT(htt)->focus_window,
				      0, event->xclient.serial);
		goto error_imp_create_35;
	    }
	} else {
	    CURRENT_CLIENT(htt)->window_type |= FC_SAME_ROOT_STATUS_GC;
	}

	if (mask & XIMP_STS_FONT_MASK_BC) {
	    CURRENT_CLIENT(htt)->status_fontname =
		GetXimpSubProperty(window, IMA_STATUSFONT, XA_STRING);
	    CURRENT_CLIENT(htt)->window_type &= ~FC_SAME_ROOT_STATUS_GC;
	} else
	    CURRENT_CLIENT(htt)->window_type |= FC_SAME_ROOT_STATUS_FONT;
    }
    CURRENT_CLIENT(htt)->style2 = XIMP_FE_TYPE1;
    rc = CreateStatusWindow();
    if (rc != 0)
	goto error_imp_create_35;
    rc = CreatePreeditWindow();
    if (rc != 0)
	goto error_imp_create_35;

    CreateWindows( CURRENT_CLIENT(htt) );

    if(lookup_info->style == LOOKUP_MENU_POPUPWINDOW )
        CURRENT_CLIENT(htt)->lookup_window = lookup_info->luc_win[CURRENT_CLIENT(htt)->screen];
    else
        CURRENT_CLIENT(htt)->lookup_window = root_client->lookup_window;
    if ( ( CURRENT_CLIENT(htt)->style2 & XIMP_FE_TYPE2 ) == XIMP_FE_TYPE2 ) {
	XSelectInput( display, CURRENT_CLIENT(htt)->focus_window,
					KeyPressMask | StructureNotifyMask );
	CURRENT_CLIENT(htt)->frontend_key_press_mask = 1;
    } else {
        XSelectInput( display,
			CURRENT_CLIENT(htt)->focus_window, StructureNotifyMask );
    }

    imlimgr_client_init(CURRENT_CLIENT(htt));
    if(!iml_open(CURRENT_CLIENT(htt))) {
	goto error_imp_create_35;
    }

    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	XimpSendEvent(CURRENT_CLIENT(htt)->focus_window,
		XIMP_CREATE_RETURN_BC, CURRENT_CLIENT(htt), 0, 0, 0);
    } else if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP ) {
	XimpSendEvent(CURRENT_CLIENT(htt)->focus_window,
		XIMP_CREATE_RETURN, CURRENT_CLIENT(htt), 0, 0, 0);
    }

    GetLUCValue(htt, LUC_LAYOUT, &luclayout);
    ConsolidateLucIF(CURRENT_CLIENT(htt), &luclayout);

    return (0);
    /*
     * Fall into..
     */
error_imp_create_35:
    ErrorMessage(101);
    XimpSendErrorEvent(CURRENT_CLIENT(htt)->focus_window, 0,
			event->xclient.serial, XIMP_BadAlloc, 0);
    DeleteClient(CURRENT_CLIENT(htt));
    return (-1);
}

Static int
XimpCreate_40(event)
    XEvent         *event;
{
    Display	   *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);
    LookupInfo     *lookup_info = (LookupInfo *)GET_HTT_VALUE(htt, lookup_info);

    Window          window = event->xclient.data.l[1];
    XIMStyle        inputStyle = event->xclient.data.l[2];
    unsigned long   mask = event->xclient.data.l[3];
    unsigned long   client_eventmask = event->xclient.data.l[4];
    FXimp_Client   *ximp_client;
    char           *GetXimpSubProperty();
    Window         *focus_window;
    int             rc;
    char           *ximp_version, prop_name[32];
    Ximp_StatusPropRec status, *current_status;
    Ximp_PreeditPropRec preedit, *current_preedit;
    XIMStyle2	   *style2;
    long                 input_mask = KeyPressMask | StructureNotifyMask ;
    LayoutInfo	   luclayout;

    if (inputStyle == 0) {
	ErrorMessage(101);
	XimpSendErrorEvent(window, 0, event->xclient.serial, XIMP_BadStyle, 0);
	return (-1);
    }
    ximp_client = NewClient(window);
    if (!ximp_client) {
	ErrorMessage(103);
	XimpSendErrorEvent(window, 0, event->xclient.serial,
			   XIMP_BadAlloc, XIMP_E_MAX_USER);
	return (-1);
    }
        if(inputStyle & XIMPreeditNothing || inputStyle & XIMStatusNothing)
                XMapRaised(display, root_client->window);
    SET_HTT_VALUE(htt, current_client, ximp_client);
    CURRENT_CLIENT(htt)->prot_type = FPRT_XIM;
    CURRENT_CLIENT(htt)->imp_mode = FIMP_CREATE;
    Fj_InitialMode();
    CURRENT_CLIENT(htt)->style = inputStyle;

    ximp_version = GetXimpSubProperty(window, IMA_VERSION, XA_STRING);
    Ximp_check_version( ximp_version );
    if (mask & XIMP_FOCUS_WIN_MASK) { /* HACK */
	focus_window = (Window *) GetXimpSubProperty(window,
						     IMA_FOCUS, AnyPropertyType);
	if (focus_window) {
	    CURRENT_CLIENT(htt)->focus_window = *focus_window;
	    XFree((char *) focus_window);
	} else {
	    ErrorMessage(108, _XIMP_FOCUS);
	    XimpSendErrorEvent(CURRENT_CLIENT(htt)->focus_window, 0,
			     event->xclient.serial, XIMP_BadFocusWindow, 0);
	    DeleteClient(CURRENT_CLIENT(htt));
	    return (-1);
	}
    } else {
	ErrorMessage(108, _XIMP_FOCUS);
	XimpSendErrorEvent(CURRENT_CLIENT(htt)->focus_window, 0,
			   event->xclient.serial, XIMP_BadFocusWindow, 0);
	DeleteClient(CURRENT_CLIENT(htt));
	return (-1);
    }
    if(client_eventmask &(KeyPress|KeyRelease) == (KeyPress|KeyRelease))
	(CURRENT_CLIENT(htt))->input_mask = client_eventmask ; /* HACK */

    EntryFocusWindow( CURRENT_CLIENT(htt), CURRENT_CLIENT(htt)->focus_window );

    current_preedit = CURRENT_CLIENT(htt)->preedit;
    *current_preedit = *root_client->preedit;
    if ( CURRENT_CLIENT(htt)->style
	& ( XIMPreeditPosition | XIMPreeditNothing | XIMPreeditArea ) ) {
	if ( mask & XSF_PRE_MASK ) {
	    rc = GetPreeditPropRec(window, current_preedit, mask);
	    if (rc != 0) {
		GetPropErrorSendEvent(rc, CURRENT_CLIENT(htt)->focus_window,
				      0, event->xclient.serial);
		goto error_imp_create_40;
	    }
	} else {
	    CURRENT_CLIENT(htt)->window_type |= FC_SAME_ROOT_PREEDIT_GC;
	}

	if (mask & XIMP_PRE_FONT_MASK) {
	    CURRENT_CLIENT(htt)->preedit_fontname =
		GetXimpSubProperty(window, IMA_PREEDITFONT, XA_STRING);
	    CURRENT_CLIENT(htt)->window_type &= ~FC_SAME_ROOT_PREEDIT_GC;
	} else
	    CURRENT_CLIENT(htt)->window_type |= FC_SAME_ROOT_PREEDIT_FONT;
    }
    current_status = CURRENT_CLIENT(htt)->status;
    *current_status = *root_client->status;
    if (CURRENT_CLIENT(htt)->style & (XIMStatusArea | XIMStatusNothing)) {
	if ( mask & XSF_STS_MASK ) {
	    rc = GetStatusPropRec(window, current_status, mask);
	    if (rc != 0) {
		GetPropErrorSendEvent(rc, CURRENT_CLIENT(htt)->focus_window,
				      0, event->xclient.serial);
		goto error_imp_create_40;
	    }
	} else {
	    CURRENT_CLIENT(htt)->window_type |= FC_SAME_ROOT_STATUS_GC;
	}

	if (mask & XIMP_STS_FONT_MASK) {
	    CURRENT_CLIENT(htt)->status_fontname =
		GetXimpSubProperty(window, IMA_STATUSFONT, XA_STRING);
	    CURRENT_CLIENT(htt)->window_type &= ~FC_SAME_ROOT_STATUS_GC;
	} else
	    CURRENT_CLIENT(htt)->window_type |= FC_SAME_ROOT_STATUS_FONT;
    }
    CURRENT_CLIENT(htt)->style2 = XIMP_FE_TYPE1;
    if ( mask & XIMP_SERVERTYPE_MASK ) {
#define	XIMSTYLE2_MASK1		( XIMP_BACKEND | XIMP_FRONTEND )
#define	XIMSTYLE2_MASK2		( XIMP_TYPE1 | XIMP_TYPE2 | XIMP_TYPE3 )
	style2 = (XIMStyle2 *)GetXimpSubProperty( window, IMA_TYPE, IMA_TYPE );
	if ( style2 ) {
	    CURRENT_CLIENT(htt)->style2 = *style2;
	    XFree((char *)style2);
	} else {
	    ErrorMessage(108, _XIMP_TYPE);
	    XimpSendErrorEvent( CURRENT_CLIENT(htt)->focus_window, 0,
			     event->xclient.serial, XIMP_BadStyle, 0);
	    DeleteClient(CURRENT_CLIENT(htt));
	    return (-1);
	}
	if ( !( CURRENT_CLIENT(htt)->style2 & XIMSTYLE2_MASK1 )
	  || !( CURRENT_CLIENT(htt)->style2 & XIMSTYLE2_MASK2 )
	  || ( ( CURRENT_CLIENT(htt)->style2 & XIMSTYLE2_MASK1 ) == XIMSTYLE2_MASK1 )
	  || ( ( CURRENT_CLIENT(htt)->style2 & XIMSTYLE2_MASK2 ) == XIMSTYLE2_MASK2 ) ) {
	    ErrorMessage(108, _XIMP_TYPE);
	    XimpSendErrorEvent( CURRENT_CLIENT(htt)->focus_window, 0,
			     event->xclient.serial, XIMP_BadStyle, 0);
	    DeleteClient(CURRENT_CLIENT(htt));
	    return (-1);
	}
    }
    rc = CreateStatusWindow();
    if (rc != 0)
	goto error_imp_create_40;
    rc = CreatePreeditWindow();
    if (rc != 0)
	goto error_imp_create_40;

    CreateWindows( CURRENT_CLIENT(htt) );

    if(lookup_info->style == LOOKUP_MENU_POPUPWINDOW )
        CURRENT_CLIENT(htt)->lookup_window = lookup_info->luc_win[CURRENT_CLIENT(htt)->screen];
    else
        CURRENT_CLIENT(htt)->lookup_window = root_client->lookup_window;

    if ( ( CURRENT_CLIENT(htt)->style2 & XIMP_FE_TYPE2 ) == XIMP_FE_TYPE2 ) {
	if((CURRENT_CLIENT(htt))->input_mask & KeyReleaseMask)
	    input_mask |= KeyReleaseMask ;
	XSelectInput( display, CURRENT_CLIENT(htt)->focus_window,
					input_mask );
	CURRENT_CLIENT(htt)->frontend_key_press_mask = 1;
    } else if ( ( CURRENT_CLIENT(htt)->style2 & XIMP_FE_TYPE3 ) == XIMP_FE_TYPE3 ) {
	XSelectInput( display, CURRENT_CLIENT(htt)->focus_window,
					KeyPressMask | StructureNotifyMask );
	CURRENT_CLIENT(htt)->frontend_key_press_mask = 1;
    } else {
        XSelectInput( display,
			CURRENT_CLIENT(htt)->focus_window, StructureNotifyMask );
    }

    imlimgr_client_init(CURRENT_CLIENT(htt));
    if(!iml_open(CURRENT_CLIENT(htt))) {
        goto error_imp_create_40;
    }

    if        ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	XimpSendEvent(CURRENT_CLIENT(htt)->focus_window,
		XIMP_CREATE_RETURN_BC, CURRENT_CLIENT(htt), 0, 0, 0);
    } else if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP ) {
	XimpSendEvent(CURRENT_CLIENT(htt)->focus_window,
		XIMP_CREATE_RETURN, CURRENT_CLIENT(htt), 0, 0, 0);
    }

    GetLUCValue(htt, LUC_LAYOUT, &luclayout);
    ConsolidateLucIF(CURRENT_CLIENT(htt), &luclayout);

    return (0);
    /*
     * Fall into...
     */
error_imp_create_40:
    ErrorMessage(101);
    XimpSendErrorEvent(CURRENT_CLIENT(htt)->focus_window, 0,
			event->xclient.serial, XIMP_BadAlloc, 0);
    DeleteClient(CURRENT_CLIENT(htt));
    return (-1);
}

static void
Ximp_check_version( ver )
    char	   *ver;
{

    if        ( strcmp( ver, "XIMP.3.4" ) == 0 ) {
	CURRENT_CLIENT(htt)->ximp_version = XIMP_PROTO_35_GRP;
    } else if ( strcmp( ver, "XIMP.3.5" ) == 0 ) {
	CURRENT_CLIENT(htt)->ximp_version = XIMP_PROTO_35_GRP;
    } else if ( strcmp( ver, "XIMP_1.0" ) == 0 ) {
	CURRENT_CLIENT(htt)->ximp_version = XIMP_PROTO_40_GRP;
    } else if ( strcmp( ver, "XIMP.4.0" ) == 0 ) {
	CURRENT_CLIENT(htt)->ximp_version = XIMP_PROTO_40_GRP;
    }
    return;
}

Static int
GetPreeditPropRec(window, current_preedit, mask)
    Window		 window;
    Ximp_PreeditPropRec *current_preedit;
    unsigned long	 mask;
{
    Ximp_PreeditPropRec		 preedit;
    Ximp_PreeditPropRec_BC	 preedit_bc;
    int			 rc;

    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP ) {
	rc = GetXimpProperty(window, IMA_PREEDIT, &preedit,
			 sizeof(Ximp_PreeditPropRec), _XIMP_PREEDIT);
    } else {
	rc = GetXimpProperty(window, IMA_PREEDIT, &preedit_bc,
			 sizeof(Ximp_PreeditPropRec_BC), _XIMP_PREEDIT);
	preedit.Area         = preedit_bc.Area;
	preedit.AreaNeeded   = preedit_bc.AreaNeeded;
	preedit.SpotLocation = preedit_bc.SpotLocation;
	preedit.Colormap     = preedit_bc.Colormap;
	preedit.Foreground   = preedit_bc.Foreground;
	preedit.Background   = preedit_bc.Background;
	preedit.Bg_Pixmap    = preedit_bc.Bg_Pixmap;
	preedit.LineSpacing  = preedit_bc.LineSpacing;
	preedit.Cursor       = preedit_bc.Cursor;
    }
    if (rc != 0)
	return (rc);
    return SetPreeditPropRec(current_preedit, &preedit, mask);
}

SetDefaultPreeditXNArea(cl, current_preedit)
    FXimp_Client	*cl;
    Ximp_PreeditPropRec *current_preedit;
{
    Window w;
    Window root;
    int x, y;
    u_int width, height, bw, depth;
    Status rc;
    Display            *display = GET_HTT_VALUE(htt, display);
 
    if (cl->focus_window > 0) {
          w = cl->focus_window;
    } else {
          w = cl->window;
    }
    rc = XGetGeometry(display, w, &root,
                         &x, &y, &width, &height, &bw, &depth);
    current_preedit->Area.x = 0;
    current_preedit->Area.y = 0;
    current_preedit->Area.width = width;
    current_preedit->Area.height = height;
}

Static int
SetPreeditPropRec(current_preedit, preedit, mask)
    Ximp_PreeditPropRec *current_preedit, *preedit;
    unsigned long   mask;
{
    Display            *display = GET_HTT_VALUE(htt, display);

    mask = DropPreeditXICMask(CURRENT_CLIENT(htt), mask);

    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP ) {
        if (mask & XIMP_PRE_AREA_MASK){
	    current_preedit->Area = preedit->Area;
	    CURRENT_CLIENT(htt)->xnarea_set = True;
        } else {
	    SetDefaultPreeditXNArea(CURRENT_CLIENT(htt), current_preedit);
        }
        if (mask & XIMP_PRE_FG_MASK)
	    current_preedit->Foreground = preedit->Foreground;
        if (mask & XIMP_PRE_BG_MASK)
	    current_preedit->Background = preedit->Background;
        if (mask & XIMP_PRE_COLORMAP_MASK)
	    current_preedit->Colormap = preedit->Colormap;
        if (mask & XIMP_PRE_STD_COLORMAP_MASK)
	    current_preedit->StdColormap = preedit->StdColormap;
        if (mask & XIMP_PRE_BGPIXMAP_MASK)
	    current_preedit->Bg_Pixmap = preedit->Bg_Pixmap;
        if (mask & XIMP_PRE_LINESP_MASK)
	    current_preedit->LineSpacing = preedit->LineSpacing;
        if (mask & XIMP_PRE_CURSOR_MASK)
	    current_preedit->Cursor = preedit->Cursor;
        if (mask & XIMP_PRE_AREANEED_MASK)
	    current_preedit->AreaNeeded = preedit->AreaNeeded;
        if (mask & XIMP_PRE_SPOTL_MASK)
	    current_preedit->SpotLocation = preedit->SpotLocation;
    } else {
        if (mask & XIMP_PRE_AREA_MASK_BC)
	    current_preedit->Area = preedit->Area;
        if (mask & XIMP_PRE_FG_MASK_BC)
	    current_preedit->Foreground = preedit->Foreground;
        if (mask & XIMP_PRE_BG_MASK_BC)
	    current_preedit->Background = preedit->Background;
        if (mask & XIMP_PRE_COLORMAP_MASK_BC)
	    current_preedit->Colormap = preedit->Colormap;
        if (mask & XIMP_PRE_BGPIXMAP_MASK_BC)
	    current_preedit->Bg_Pixmap = preedit->Bg_Pixmap;
        if (mask & XIMP_PRE_LINESP_MASK_BC)
	    current_preedit->LineSpacing = preedit->LineSpacing;
        if (mask & XIMP_PRE_CURSOR_MASK_BC)
	    current_preedit->Cursor = preedit->Cursor;
        if (mask & XIMP_PRE_AREANEED_MASK_BC)
	    current_preedit->AreaNeeded = preedit->AreaNeeded;
        if (mask & XIMP_PRE_SPOTL_MASK_BC)
	    current_preedit->SpotLocation = preedit->SpotLocation;
    }
    GetPreeditColormap( current_preedit );
    return (0);
}

Static int
GetStatusPropRec(window, current_status, mask)
    Window          window;
    Ximp_StatusPropRec *current_status;
    unsigned long   mask;
{
    Ximp_StatusPropRec		status;
    Ximp_StatusPropRec_BC	status_bc;
    int				rc;

    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP ) {
	rc = GetXimpProperty(window, IMA_STATUS, &status,
			 sizeof(Ximp_StatusPropRec), _XIMP_STATUS);
    } else {
	rc = GetXimpProperty(window, IMA_STATUS, &status_bc,
			 sizeof(Ximp_StatusPropRec_BC), _XIMP_STATUS);
	status.Area        = status_bc.Area;
	status.AreaNeeded  = status_bc.AreaNeeded;
	status.Colormap    = status_bc.Colormap;
	status.Foreground  = status_bc.Foreground;
	status.Background  = status_bc.Background;
	status.Bg_Pixmap   = status_bc.Bg_Pixmap;
	status.LineSpacing = status_bc.LineSpacing;
	status.Cursor      = status_bc.Cursor;
	status.window      = status_bc.window;
    }
    if (rc != 0)
	return (rc);
    return SetStatusPropRec(current_status, &status, mask);
}

Static int
SetStatusPropRec(current_status, status, mask)
    Ximp_StatusPropRec *current_status, *status;
    unsigned long   mask;
{
    mask = DropStatusXICMask(CURRENT_CLIENT(htt), mask);

    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP ) {
        if (mask & XIMP_STS_AREA_MASK)
	    current_status->Area = status->Area;
        if (mask & XIMP_STS_FG_MASK)
	    current_status->Foreground = status->Foreground;
        if (mask & XIMP_STS_BG_MASK)
	    current_status->Background = status->Background;
        if (mask & XIMP_STS_COLORMAP_MASK)
	    current_status->Colormap = status->Colormap;
        if (mask & XIMP_STS_STD_COLORMAP_MASK)
	    current_status->StdColormap = status->StdColormap;
        if (mask & XIMP_STS_BGPIXMAP_MASK)
	    current_status->Bg_Pixmap = status->Bg_Pixmap;
        if (mask & XIMP_STS_LINESP_MASK)
	    current_status->LineSpacing = status->LineSpacing;
        if (mask & XIMP_STS_CURSOR_MASK)
	    current_status->Cursor = status->Cursor;
        if (mask & XIMP_STS_AREANEED_MASK)
	    current_status->AreaNeeded = status->AreaNeeded;
        if (mask & XIMP_STS_WINDOW_MASK) {
	    current_status->window = status->window;
	    CURRENT_CLIENT(htt)->ext_ui_statuswindow = 1;
	}
    } else {
        if (mask & XIMP_STS_AREA_MASK_BC)
	    current_status->Area = status->Area;
        if (mask & XIMP_STS_FG_MASK_BC)
	    current_status->Foreground = status->Foreground;
        if (mask & XIMP_STS_BG_MASK_BC)
	    current_status->Background = status->Background;
        if (mask & XIMP_STS_COLORMAP_MASK_BC)
	    current_status->Colormap = status->Colormap;
        if (mask & XIMP_STS_BGPIXMAP_MASK_BC)
	    current_status->Bg_Pixmap = status->Bg_Pixmap;
        if (mask & XIMP_STS_LINESP_MASK_BC)
	    current_status->LineSpacing = status->LineSpacing;
        if (mask & XIMP_STS_CURSOR_MASK_BC)
	    current_status->Cursor = status->Cursor;
        if (mask & XIMP_STS_AREANEED_MASK_BC)
	    current_status->AreaNeeded = status->AreaNeeded;
        if (mask & XIMP_STS_WINDOW_MASK_BC) {
	    current_status->window = status->window;
	    CURRENT_CLIENT(htt)->ext_ui_statuswindow = 1;
	}
    }
    GetStatusColormap( current_status );
    return (0);
}

Private unsigned long
DropPreeditXICMask(client, mask)
    FXimp_Client	*client;
    unsigned long	mask;
{
    unsigned long	drop_mask = 0;

    if(client->ximp_version == XIMP_PROTO_40_GRP) {
	if(client->style & XIMPreeditNothing) 
		drop_mask = (XIMP_PRE_AREA_MASK | XIMP_PRE_AREANEED_MASK |
			     XIMP_PRE_SPOTL_MASK);
	if(client->style & XIMPreeditArea) 
		drop_mask = XIMP_PRE_SPOTL_MASK;
	if(client->style & XIMPreeditPosition)
		drop_mask = XIMP_PRE_AREANEED_MASK;
    }
    else {
	if(client->style & XIMPreeditNothing) 
		drop_mask = (XIMP_PRE_AREA_MASK_BC | XIMP_PRE_AREANEED_MASK_BC |
			     XIMP_PRE_SPOTL_MASK_BC);
	if(client->style & XIMPreeditArea) 
		drop_mask = XIMP_PRE_SPOTL_MASK_BC;
	if(client->style & XIMPreeditPosition)
		drop_mask = XIMP_PRE_AREANEED_MASK_BC;
    }
    return (mask &= ~drop_mask);
}

Private unsigned long
DropStatusXICMask(client, mask)
    FXimp_Client	*client;
    unsigned long	mask;
{
    unsigned long 	drop_mask = 0;

    if(client->ximp_version == XIMP_PROTO_40_GRP) {
	if(client->style & XIMStatusNothing) 
		drop_mask = (XIMP_STS_AREA_MASK | XIMP_STS_AREANEED_MASK);
    }
    else {
	if(client->style & XIMStatusNothing) 
		drop_mask = (XIMP_STS_AREA_MASK_BC | XIMP_STS_AREANEED_MASK_BC);
    }

    return (mask &= ~drop_mask);
}

Static char    *
GetXimpSubProperty(window, atomid, type)
    Window          window;
    Atom            atomid;
    Atom            type;
{
    Display         *display = GET_HTT_VALUE(htt, display);
    
    Atom            actual_type_ret;
    int             actual_format_ret;
    unsigned long   nitems_ret;
    unsigned long   bytes_after_ret;
    unsigned char  *win_data;

    if (atomid == 0)
	return ((char *) 0);

    XGetWindowProperty(display, window, atomid, 0L, 8192L,
	      True, type, &actual_type_ret, &actual_format_ret, &nitems_ret,
		       &bytes_after_ret, &win_data);
    if (actual_format_ret == 0 || nitems_ret == 0) {
	return ((char *) 0);
    }
    return ((char *) win_data);
}

Static int
GetXimpProperty(window, atomid, win_area, size, type_name)
    Window          window;
    Atom            atomid;
    char           *win_area;
    int             size;
    char           *type_name;
{
    Display         *display = GET_HTT_VALUE(htt, display);

    Atom            actual_type_ret;
    int             actual_format_ret;
    unsigned long   nitems_ret;
    unsigned long   bytes_after_ret;
    unsigned char  *win_data;

    if (atomid) {
	XGetWindowProperty(display, window, atomid, 0L, 1000000L,
	    True, atomid, &actual_type_ret, &actual_format_ret, &nitems_ret,
			   &bytes_after_ret, &win_data);
	if (actual_format_ret == 0) {
	    ErrorMessage(108, type_name);
	    return (-2);
	}
	if ((nitems_ret * 4) != size) {
	    ErrorMessage(109, type_name, nitems_ret * 4);
	    XFree((char *) win_data);
	    return (-3);
	}
	bcopy(win_data, win_area, size);
	XFree((char *) win_data);
    } else
	return (-1);
    return (0);
}

#ifdef DEBUG
dbg_PreeditDump(preedit, mode)
    Ximp_PreeditPropRec *preedit;
    Bool		 mode;
{
    Ximp_PreeditPropRec_BC *preedit_bc = (Ximp_PreeditPropRec_BC *)preedit;

    if ( ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP ) || !mode ) {
	dbg_printf("  Preedit : Area.x=%d Area.y=%d Area.w=%d Area.h=%d fg=%x bg=%x\n",
	       preedit->Area.x, preedit->Area.y,
	       preedit->Area.width, preedit->Area.height,
	       preedit->Foreground, preedit->Background );
	dbg_printf("     colormap=%x std_col=%x bgpix=%x lineg=%d curs=%x a.w=%d a.h=%d sl.x=%d sl.y=%d\n",
	       preedit->Colormap, preedit->StdColormap, preedit->Bg_Pixmap,
	       preedit->LineSpacing, preedit->Cursor,
	       preedit->AreaNeeded.width, preedit->AreaNeeded.height,
	       preedit->SpotLocation.x, preedit->SpotLocation.y);
    } else {
	dbg_printf("  Preedit : Area.x=%d Area.y=%d Area.w=%d Area.h=%d fg=%x bg=%x\n",
	       preedit_bc->Area.x, preedit_bc->Area.y,
	       preedit_bc->Area.width, preedit_bc->Area.height,
	       preedit_bc->Foreground, preedit_bc->Background );
	dbg_printf("     colormap=%x bgpix=%x lineg=%d curs=%x a.w=%d a.h=%d sl.x=%d sl.y=%d\n",
	       preedit_bc->Colormap, preedit_bc->Bg_Pixmap,
	       preedit_bc->LineSpacing, preedit_bc->Cursor,
	       preedit_bc->AreaNeeded.width, preedit_bc->AreaNeeded.height,
	       preedit_bc->SpotLocation.x, preedit_bc->SpotLocation.y);
    }
}

dbg_StatusDump(status, mode)
    Ximp_StatusPropRec *status;
    Bool		mode;
{
    Ximp_StatusPropRec_BC *status_bc = (Ximp_StatusPropRec_BC *)status;

    if ( ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP ) || !mode ) {
	dbg_printf("  Status : x=%d y=%d w=%d h=%d fg=%x bg=%x colo=%x bgpix=%x LS=%d curs=%x a.w=%d a.h=%d wid=%x\n",
	       status->Area.x, status->Area.y,
	       status->Area.width, status->Area.height,
	       status->Foreground, status->Background,
	       status->Colormap, status->Bg_Pixmap,
	       status->LineSpacing, status->Cursor,
	       status->AreaNeeded.width, status->AreaNeeded.height,
	       status->window);
    } else {
	dbg_printf("  Status : x=%d y=%d w=%d h=%d fg=%x bg=%x colo=%x bgpix=%x LS=%d curs=%x a.w=%d a.h=%d wid=%x\n",
	       status_bc->Area.x, status_bc->Area.y,
	       status_bc->Area.width, status_bc->Area.height,
	       status_bc->Foreground, status_bc->Background,
	       status_bc->Colormap, status_bc->Bg_Pixmap,
	       status_bc->LineSpacing, status_bc->Cursor,
	       status_bc->AreaNeeded.width, status_bc->AreaNeeded.height,
	       status_bc->window);
    }
}
#endif				/* DEBUG */

Static int
GetPropErrorSendEvent(rc, focus_window, icid, serial)
    long            rc;
    Window          focus_window;
    unsigned long   icid, serial;
{
    if (rc == -2)
	XimpSendErrorEvent(focus_window, icid, serial, XIMP_BadProperty, 0);
    if (rc == -3)
	XimpSendErrorEvent(focus_window, icid, serial, XIMP_BadPropertyType, 0);
    return (0);
}

Static int
XimpSendEvent(window, imp_func, icid, data1, data2, data3)
    Window          window;
    unsigned long   imp_func, icid, data1, data2, data3;
{
    Display         *display = GET_HTT_VALUE(htt, display);
    XEvent          event;

    bzero(&event, sizeof(event));
    event.type = ClientMessage;
    event.xclient.format = 32;
    event.xclient.window = window;
    event.xclient.message_type = GET_HTT_VALUE(htt, IMA_IMPROTOCOL);
    event.xclient.data.l[0] = imp_func;
    event.xclient.data.l[1] = icid;
    event.xclient.data.l[2] = data1;
    event.xclient.data.l[3] = data2;
    event.xclient.data.l[4] = data3;
    XSendEvent(display, window, False, NoEventMask, &event);
    XFlush(display);
    return (0);
}

static int
XimpSendEvent2(ic, event, format)
    FXimp_Client   *ic;
    XEvent         *event;
    int             format;
{
    Display     *display = GET_HTT_VALUE(htt, display);

    event->type = ClientMessage;
    event->xclient.format = format;
    event->xclient.window = ic->focus_window;
    event->xclient.message_type = GET_HTT_VALUE(htt, IMA_IMPROTOCOL);
    XSendEvent(display, ic->focus_window, False, NoEventMask, event);
    XFlush(display);
    return (0);
}

static          Atom
XimpReplaceProp(ic, prop_key, type, str, len, format)
    FXimp_Client   *ic;
    char           *prop_key;
    Atom            type;
    char           *str;
    int             len;
    int             format;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);
    Atom            atom;
    char            prop_name[32];

    (void) sprintf(prop_name, "%s%d", prop_key, ic);
    atom = XInternAtom(display, prop_name, False);
    XChangeProperty(display, root_client->window, atom, type, format,
		    PropModeReplace, (unsigned char *) str, len);
    XFlush(display);
    return (atom);
}

static          Atom
XimpReplacePropPool(ic, type, str, len, format)
    FXimp_Client   *ic;
    Atom            type;
    char           *str;
    int             len;
    int             format;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);
    Atom            atom;
    char            prop_name[32];

    atom = XimpAtomPool((XPropertyEvent *)NULL);
    XChangeProperty(display, root_client->window, atom, type, format,
		    PropModeReplace, (unsigned char *) str, len);
    XFlush(display);
    return (atom);
}

Atom
XimpAtomPool(evp)
    XPropertyEvent	*evp;
{
    static int	index = 0;
    static int	number = 0;
    static int	pool_size = 0;
    static char prop_name[CALLBACKS_PROPNAME_LEN];
    static Atom *pool;
    Atom   this_atom;
    Display        *display = GET_HTT_VALUE(htt, display);

    if(pool_size == 0){
	pool = (Atom *)malloc(sizeof(Atom) * MAX_CALLBACKS_PROP);
	pool_size = MAX_CALLBACKS_PROP;
    }

    if(evp == (XPropertyEvent *)NULL) {
        if(index == 0) {
    	    bzero(prop_name, CALLBACKS_PROPNAME_LEN);
    	    sprintf(prop_name, "%s%X","_XIMP_NORMALPROP_", number++) ;
	    this_atom = XInternAtom(display, prop_name, False);
        }
        else {
	    this_atom = pool[--index];
	}
    }
    else {
	if(evp->state != PropertyDelete)
		return (Atom)NULL;
	if(index >= pool_size - 1) {
		pool = (Atom *)
		    realloc(pool, sizeof(Atom) * (pool_size + MAX_CALLBACKS_PROP));
		pool_size += MAX_CALLBACKS_PROP;
	}
	pool[index++] = evp->atom;
		return (Atom)NULL;
    }
    return this_atom;
}

static          Atom
XimpAppendProp(ic, prop_key, type, str, len, format)
    FXimp_Client   *ic;
    char           *prop_key;
    Atom            type;
    char           *str;
    int             len;
    int             format;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    Atom            atom;
    char            prop_name[32];

    (void) sprintf(prop_name, "%s%d", prop_key, ic);
    atom = XInternAtom(display, prop_name, False);
    XChangeProperty(display, CURRENT_CLIENT(htt)->focus_window, atom, type, format,
		    PropModeAppend, (unsigned char *) str, len);
    XFlush(display);
    return (atom);
}

int
XimpCommitSendProp(ic, csstr, cslen)
    FXimp_Client   *ic;
    char           *csstr;
    int             cslen;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    XEvent          event;

    bzero(&event, sizeof(event));
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	event.xclient.data.l[0] = XIMP_READPROP_BC;
    } else {
	event.xclient.data.l[0] = XIMP_READPROP;
    }
    event.xclient.data.l[1] = (long) ic;
    event.xclient.data.l[2] =
	XimpReplacePropPool(ic, IMA_COMPOUND_TEXT, csstr, cslen, 8);
    XimpSendEvent2(ic, &event, 32);
    XFlush(display);
    return (0);
}
 /*
  * Reset return protocol detail
  */
#define XIMP3_RESET_RETURN_ATOM   2
#define XIMP4_RESET_RETURN_DETAIL 2
#    define NO_RESET_DATA       0
#    define RESET_DATA_VIA_CM   1
#    define RESET_DATA_VIA_PROP 2
#define XIMP4_RESET_RETURN_ATOM   3
int
XimpResetReturn(ic, csstr, cslen)
    FXimp_Client   *ic;
    char           *csstr;
    int             cslen;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    XEvent          event;

    if(!cslen || !csstr){
    	XimpSendEvent(CURRENT_CLIENT(htt)->focus_window,
                        XIMP_RESET_RETURN, ic, NO_RESET_DATA, 0, 0);
	return 0 ;
    }
    if(cslen < 250){
	XimpSendEvent(CURRENT_CLIENT(htt)->focus_window,
		      XIMP_RESET_RETURN, ic, RESET_DATA_VIA_CM, 0, 0);
	XimpCommitSendCmsg(ic, csstr, cslen);
    } else {
	XimpSendEvent(CURRENT_CLIENT(htt)->focus_window,
		      XIMP_RESET_RETURN, ic, RESET_DATA_VIA_PROP,
		      XimpReplacePropPool(ic, IMA_COMPOUND_TEXT, csstr, cslen, 8),
		      0);
    }
    XFlush(display);
    return (0);
}

int
XimpCommitSendCmsg(ic, commit_text, commit_length)
    FXimp_Client   *ic;
    char           *commit_text;
    int             commit_length;
{
    Ximp_send_compound_text( ic, commit_text, commit_length );
    return (0);
}

int
XimpPreEditStartSend(ic)
    FXimp_Client   *ic;
{
    Display	   *display = GET_HTT_VALUE(htt, display);
    XEvent          event;

    bzero(&event, sizeof(event));
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	event.xclient.data.l[0] = XIMP_PREEDITSTART_BC;
    } else {
	event.xclient.data.l[0] = XIMP_PREEDITSTART;
    }
    event.xclient.data.l[1] = (long) ic;
    XimpSendEvent2(ic, &event, 32);
    XFlush(display);
    return (0);
}

int
XimpPreEditDrawSend( ic, pds )
    FXimp_Client			*ic;
    XIMPreeditDrawCallbackStruct	*pds;
{
    int		 compound_text_len = 0;
    int		 size;
    char	*compound_text = NULL;

    if ( pds->text ) {
	size = 5 * ( pds->text->length + 1 );
        compound_text = (char *)malloc( size );
	bzero( compound_text, size );
	Xsf_XIMTextToCompound( pds->text,
			compound_text, &compound_text_len);
    }
    if ( client_is_cmsg_only ) {
	XimpPreEditDrawSendCmsg( ic, pds,
			compound_text, compound_text_len );
    } else {
	/*
	 * Because of Ximp design bug, we need to use prop always
	 * when text deletion occurs, so put (pds->text == NULL ).
	 */
	if 	  ( ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP )
		 && ( compound_text_len > XSF_COMMIT_CMSG ) ) {
	    XimpPreEditDrawSendProp( ic, pds,
				compound_text, compound_text_len );
	} else if ( ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP )
		 && ( compound_text_len > XSF_COMMIT_CMSG_MAX ) ) {
	    XimpPreEditDrawSendProp( ic, pds,
				compound_text, compound_text_len );
	} else {
	    XimpPreEditDrawSendCmsg( ic, pds,
				compound_text, compound_text_len );
	}
    }
    if ( compound_text )
	free( compound_text );
    return;
}

int
XimpPreEditDrawSendProp(ic, pds, textarea, pdslen)
    FXimp_Client   *ic;
    XIMPreeditDrawCallbackStruct *pds;
    char           *textarea;
    int             pdslen;
{
    Display	   *display = GET_HTT_VALUE(htt, display);
    XEvent          event;
    long            atom1[4];

    bzero(&event, sizeof(event));
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	event.xclient.data.l[0] = XIMP_PREEDITDRAW_BC;
    } else {
	event.xclient.data.l[0] = XIMP_PREEDITDRAW;
    }
    event.xclient.data.l[1] = (long) ic;
    atom1[0] = (long) pds->caret;
    atom1[1] = (long) pds->chg_first;
    atom1[2] = (long) pds->chg_length;
    atom1[3] = 0;
    event.xclient.data.l[2] =
	XimpReplacePropPool(ic, IMA_PREEDIT_DRAW_DATA, (char *) atom1, 3, 32);
    event.xclient.data.l[3] =
	XimpReplacePropPool(ic, IMA_COMPOUND_TEXT, textarea, pdslen, 8);

    if (pds->text) {
	event.xclient.data.l[4] =
	    XimpReplacePropPool(ic, IMA_FEEDBACKS,
			(char *) pds->text->feedback, pds->text->length, 32);
    } else {
	event.xclient.data.l[4] =
	    XimpReplacePropPool(ic, IMA_FEEDBACKS, NULL, NULL, 32);
    }

    XimpSendEvent2(ic, &event, 32);
    XFlush(display);
    return (0);
}

int
XimpPreEditDrawSendCmsg(ic, pds, textarea, pdslen)
    FXimp_Client   *ic;
    XIMPreeditDrawCallbackStruct *pds;
    char           *textarea;
    int             pdslen;
{
    Ximp_preeditdraw_cm( ic, pds, textarea, pdslen );
    return (0);
}

int
XimpPreEditDoneSend(ic)
    FXimp_Client   *ic;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    XEvent          event;

    bzero(&event, sizeof(event));
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	event.xclient.data.l[0] = XIMP_PREEDITDONE_BC;
    } else {
	event.xclient.data.l[0] = XIMP_PREEDITDONE;
    }
    event.xclient.data.l[1] = (long) ic;
    XimpSendEvent2(ic, &event, 32);
    XFlush(display);
    return (0);
}

int
XimpPreEditCaretSend(ic, pcs)
    FXimp_Client   *ic;
    XIMPreeditCaretCallbackStruct *pcs;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    XEvent          event;

    bzero(&event, sizeof(event));
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	event.xclient.data.l[0] = XIMP_PREEDITCARET;
    } else {
	event.xclient.data.l[0] = XIMP_PREEDITCARET;
    }
    event.xclient.data.l[1] = (long) ic;
    event.xclient.data.l[2] = pcs->position;
    event.xclient.data.l[3] = pcs->direction;
    event.xclient.data.l[4] = pcs->style;
    XimpSendEvent2(ic, &event, 32);
    XFlush(display);
    return (0);
}

int
XimpStatusStartSend(ic)
    FXimp_Client   *ic;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    XEvent          event;

    bzero(&event, sizeof(event));
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	event.xclient.data.l[0] = XIMP_STATUSSTART_BC;
    } else {
	event.xclient.data.l[0] = XIMP_STATUSSTART;
    }
    event.xclient.data.l[1] = (long) ic;
    XimpSendEvent2(ic, &event, 32);
    XFlush(display);
    return (0);
}

void
XimpStatusDrawSend( ic, sds )
    FXimp_Client		*ic;
    XIMStatusDrawCallbackStruct *sds;
{
    int		compound_text_len ;
    char	compound_text[512] ;

    bzero( compound_text, sizeof( compound_text ) ) ;
    Xsf_XIMTextToCompound( sds->data.text,
				compound_text, &compound_text_len) ;

    if ( ( client_is_cmsg_only )
      || ( sds->type == XIMBitmapType ) ) {
	XimpStatusDrawSendCmsg( ic, sds, compound_text, compound_text_len ) ;
    } else {
	if  ( ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP )
		 && ( compound_text_len > XSF_COMMIT_CMSG ) ) {
	    XimpStatusDrawSendProp( ic, sds,
				compound_text, compound_text_len ) ;
	} else if ( ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP )
		 && ( compound_text_len > XSF_COMMIT_CMSG_MAX ) ) {
	    XimpStatusDrawSendProp( ic, sds,
				compound_text, compound_text_len ) ;
	} else {
#ifdef USE_CMSG
	    XimpStatusDrawSendCmsg( ic, sds,
				compound_text, compound_text_len ) ;
#else /* USE_CMSG */
	    XimpStatusDrawSendProp( ic, sds,
				compound_text, compound_text_len ) ;
#endif /* USE_CMSG */
	}
    }
    return ;
}

int
XimpStatusDrawSendProp(ic, sds, textarea, sdslen)
    FXimp_Client   *ic;
    XIMStatusDrawCallbackStruct *sds;
    char           *textarea;
    int             sdslen;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    XEvent          event;

    bzero(&event, sizeof(event));
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	event.xclient.data.l[0] = XIMP_STATUSDRAW_BC;
    } else {
	event.xclient.data.l[0] = XIMP_STATUSDRAW;
    }
    event.xclient.data.l[1] = (long) ic;
    event.xclient.data.l[2] = (long) sds->type;
    if (sds->type == XIMTextType) {
	event.xclient.data.l[3] = textarea?
	    XimpReplacePropPool(ic, IMA_COMPOUND_TEXT, textarea, sdslen, 8):0;
	event.xclient.data.l[4] = (sds->data.text && sds->data.text->feedback)?
	    XimpReplacePropPool(ic, IMA_FEEDBACKS,
             (char *) sds->data.text->feedback, sds->data.text->length, 32):0;
    } else {
        event.xclient.data.l[3] = sds->data.bitmap;
    }
 
    XimpSendEvent2(ic, &event, 32);
    XFlush(display);
    return (0);
}

int
XimpStatusDrawSendCmsg(ic, sds, textarea, sdslen)
    FXimp_Client   *ic;
    XIMStatusDrawCallbackStruct *sds;
    char           *textarea;
    int             sdslen;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    XEvent          event;

    Ximp_StatusDrawCallbackPropRec *sdc =
    (Ximp_StatusDrawCallbackPropRec *) & event.xclient.data.l[0];

    bzero(&event, sizeof(event));
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	event.xclient.data.l[0] = XIMP_STATUSDRAW_CM_BC;
    } else {
	event.xclient.data.l[0] = XIMP_STATUSDRAW_CM;
    }
    event.xclient.data.l[1] = (long) ic;
    event.xclient.data.l[2] = (long) sds->type;
    if (sds->type == XIMTextType) {
	if (sds->data.text && sds->data.text->feedback) {
	    event.xclient.data.l[3] = *sds->data.text->feedback;
	} else {
	    event.xclient.data.l[3] = 0;
	}
    } else {
	event.xclient.data.l[3] = sds->data.bitmap;
    }
    XimpSendEvent2(ic, &event, 32);

    if (sds->type == XIMTextType) {
	Ximp_send_compound_text( ic, textarea, sdslen );
    }

    XFlush(display);
    return (0);
}

int
XimpStatusDoneSend(ic)
    FXimp_Client   *ic;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    XEvent          event;

    bzero(&event, sizeof(event));
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	event.xclient.data.l[0] = XIMP_STATUSDONE_BC;
    } else {
	event.xclient.data.l[0] = XIMP_STATUSDONE;
    }
    event.xclient.data.l[1] = (long) ic;
    XimpSendEvent2(ic, &event, 32);
    XFlush(display);
    return (0);
}

#ifdef notdef
int
XimpLookupStartSend(ic, lss, e)
    FXimp_Client   *ic;
    XIMLookupStartCallbackStruct *lss;
    XEvent         *e;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    XEvent          event;
    long            prop0[9];

    bzero(&event, sizeof(event));
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	event.xclient.data.l[0] = XIMP_EXTENSION_BC;
    } else {
	event.xclient.data.l[0] = XIMP_EXTENSION;
    }
    event.xclient.data.l[1] = (long) ic;
    event.xclient.data.l[2] = IMA_EXT_XIMP_LOOKUPCHOICES;
    event.xclient.data.l[3] = LOOKUP_CHOICES_START_REQ;
    prop0[0] = e->xkey.keycode;
    prop0[1] = e->xkey.state;
    prop0[2] = lss->WhoIsMaster;
    prop0[3] = lss->XIMPreference->choice_per_window;
    prop0[4] = lss->XIMPreference->nrows;
    prop0[5] = lss->XIMPreference->ncolumns;
    prop0[6] = lss->XIMPreference->DrawUpDirection;
    prop0[7] = lss->XIMPreference->WhoOwnsLabel;
    prop0[8] = 0;

    event.xclient.data.l[4] =
	XimpReplaceProp(ic, _XIMP_LOOKUP, IMA_EXT_XIMP_CHOICE_START_REQ,
		    (char *) prop0, 8, 32);

    XimpSendEvent2(ic, &event, 32);
    XFlush(display);
    return (0);
}

int
XimpLookupDrawSend(ic, lds)
    FXimp_Client   *ic;
    XIMLookupDrawCallbackStruct *lds;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    XEvent          event;
    char           *choice, **chptr;
    char           *text, *textadr;
    long           *feedback, *feedbackadr;
    int             i, ldslen, length;
    long            prop0[6];

    bzero(&event, sizeof(event));
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	event.xclient.data.l[0] = XIMP_EXTENSION_BC;
    } else {
	event.xclient.data.l[0] = XIMP_EXTENSION;
    }
    event.xclient.data.l[1] = (long) ic;
    event.xclient.data.l[2] = IMA_EXT_XIMP_LOOKUPCHOICES;
    event.xclient.data.l[3] = LOOKUP_CHOICES_DRAW_REQ;
    prop0[0] = lds->max_len;
    prop0[1] = lds->index_of_first_candidate;
    prop0[2] = lds->index_of_last_candidate;

    choice = (char *) malloc(lds->n_choices * 8);

    for (ldslen = 0, i = 0, chptr = (char **) choice; i < lds->n_choices; i++) {
	*chptr = (char *) malloc(64);
	bzero(*chptr, 64);
	Xsf_XIMTextToCompound(lds->choices[i].label, *chptr, &length);
	ldslen += length;
	chptr++;
	*chptr = (char *) malloc(64);
	bzero(*chptr, 64);
	Xsf_XIMTextToCompound(lds->choices[i].value, *chptr, &length);
	ldslen += length;
	chptr++;
	ldslen += 2;
    }

    text = (char *) malloc(ldslen);

    for (textadr = text, i = 0, chptr = (char **) choice;
	 i < lds->n_choices * 2; i++) {
	(void) strcpy(textadr, (char *) *chptr);
	textadr += strlen(*chptr);
	*textadr = 0;
	textadr++;
	chptr++;
    }

    prop0[3] = XimpReplaceProp(ic, _XIMP_LOOKUP_1, XA_COMPOUND_TEXT,
			   text, ldslen, 8);

    for (i = 0, chptr = (char **) choice; i < lds->n_choices; i++, chptr++) {
	free(*chptr);
    }
    free(choice);
    free(text);

    feedback = (long *) malloc(lds->n_choices * 8);
    for (feedbackadr = feedback, i = 0; i < lds->n_choices; i++) {
	if (lds->choices[i].label) {
	    *feedbackadr = (long) lds->choices[i].label->feedback;
	} else {
	    *feedbackadr = 0;
	}
	feedbackadr++;

	if (lds->choices[i].value) {
	    *feedbackadr = (long) lds->choices[i].value->feedback;
	} else {
	    *feedbackadr = 0;
	}
	feedbackadr++;

    }

    prop0[4] = XimpReplaceProp(ic, _XIMP_LOOKUP_2, IMA_FEEDBACKS,
			   (char *) feedback, lds->n_choices * 2, 32);
    free(feedback);

    prop0[5] = 0;
    event.xclient.data.l[4] = XimpReplaceProp(ic, _XIMP_LOOKUP_3,
					  IMA_EXT_XIMP_CHOICE_DRAW_REQ,
					  (char *) prop0, 5, 32);
    XimpSendEvent2(ic, &event, 32);
    XFlush(display);
    return (0);
}

int
XimpLookupProcessSend(ic, e)
    FXimp_Client   *ic;
    XEvent         *e;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    XEvent          event;
    long            prop0[3];

    bzero(&event, sizeof(event));
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	event.xclient.data.l[0] = XIMP_EXTENSION_BC;
    } else {
	event.xclient.data.l[0] = XIMP_EXTENSION;
    }
    event.xclient.data.l[1] = (long) ic;
    event.xclient.data.l[2] = IMA_EXT_XIMP_LOOKUPCHOICES;
    event.xclient.data.l[3] = LOOKUP_CHOICES_PROCESS_REQ;
    prop0[0] = e->xkey.keycode;
    prop0[1] = e->xkey.state;
    prop0[2] = 0;
    event.xclient.data.l[4] =
	XimpReplaceProp(ic, _XIMP_LOOKUP, IMA_EXT_XIMP_CHOICE_PROC_REQ,
		    (char *) prop0, 2, 32);

    XimpSendEvent2(ic, &event, 32);
    XFlush(display);
    return (0);
}

int
XimpLookupDoneSend(ic)
    FXimp_Client   *ic;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    XEvent          event;

    bzero(&event, sizeof(event));
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	event.xclient.data.l[0] = XIMP_EXTENSION_BC;
    } else {
	event.xclient.data.l[0] = XIMP_EXTENSION;
    }
    event.xclient.data.l[1] = (long) ic;
    event.xclient.data.l[2] = IMA_EXT_XIMP_LOOKUPCHOICES;
    event.xclient.data.l[3] = LOOKUP_CHOICES_DONE_REQ;
    XimpSendEvent2(ic, &event, 32);
    XFlush(display);
    return (0);
}

#endif

Static int
XimpSendErrorEvent(window, icid, serial, error_no, detail_error_no)
    Window          window;
    unsigned long   icid, serial;
    int             error_no, detail_error_no;
{

    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	return XimpSendEvent(window, XIMP_ERROR_BC, icid, serial,
			 error_no, detail_error_no);
    } else {
	return XimpSendEvent(window, XIMP_ERROR, icid, serial,
			 error_no, detail_error_no);
    }
}

int
XimpSendKeyEvent(key_event)
    XEvent         *key_event;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    FXimp_Client   *root_client = GET_HTT_VALUE(htt, root_client);
    XEvent          event;
    Window          window;

    if (CURRENT_CLIENT(htt) == root_client)
	return (0);
    window = CURRENT_CLIENT(htt)->focus_window;
    bzero(&event, sizeof(event));
    event.type = ClientMessage;
    event.xclient.window = window;
    event.xclient.message_type = GET_HTT_VALUE(htt, IMA_IMPROTOCOL);
    event.xclient.format = 32;
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	event.xclient.data.l[0] = XIMP_KEYPRESS_BC;
    } else {
	event.xclient.data.l[0] = XIMP_KEYPRESS;
    }
    event.xclient.data.l[1] = (long) CURRENT_CLIENT(htt);
    event.xclient.data.l[2] = CURRENT_CLIENT(htt)->outgoing_keypress.keycode = key_event->xkey.keycode;
    event.xclient.data.l[3] = CURRENT_CLIENT(htt)->outgoing_keypress.state = key_event->xkey.state;
    XSendEvent(display, window, False, NoEventMask, &event);
    CURRENT_CLIENT(htt)->keypress_hold = False;
    XFlush(display);
    return (0);
}

Static int
XimpDestroy(event)
    XEvent         *event;
{
    return XimpDestroyClient(CURRENT_CLIENT(htt), 0);
}

int
XimpDestroyClient(ximp_client, flag)
    FXimp_Client   *ximp_client;
    int             flag;
{
    Display        *display = GET_HTT_VALUE(htt, display);
   extern int      CheckRootWindow();

    SET_HTT_VALUE(htt, current_client, ximp_client);
    CURRENT_CLIENT(htt)->imp_mode = FIMP_DESTROY;
    if (flag == 0) {
	if (CURRENT_CLIENT(htt)->focus_window) {
	    XSelectInput(display, CURRENT_CLIENT(htt)->focus_window, NoEventMask);
	    CURRENT_CLIENT(htt)->frontend_key_press_mask = 0;
	}
    }
    UnsetFocusClient();
    DestroyPreeditWindow(flag);
    DestroyStatusWindow(flag);
    Lkup_End(CURRENT_CLIENT(htt));
    xsfIMLclose(CURRENT_CLIENT(htt));
    DeleteClient(CURRENT_CLIENT(htt));
    CheckRootWindow();
    return (0);
}

Static int
XimpKeypress(event)
    XEvent         *event;
{
    FXimp_ICID      icid = (FXimp_ICID) event->xclient.data.l[1];
    FXimp_Client   *ic = (FXimp_Client *)icid;
    int             keycode = event->xclient.data.l[2];
    int             state = event->xclient.data.l[3];

    event->xkey.type = KeyPress;
    event->xkey.window = CURRENT_CLIENT(htt)->focus_window;
    event->xkey.root = GET_HTT_VALUE(htt, root);
    event->xkey.subwindow = 0;
    event->xkey.x = 0;
    event->xkey.y = 0;
    event->xkey.x_root = 0;
    event->xkey.y_root = 0;
    event->xkey.keycode = keycode;
    event->xkey.state = state;
    event->xkey.same_screen = 1;

    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP )
	event->xkey.time = (Time)(event->xclient.data.l[4]);

    ic->keypress_hold = True;
    xsfKeyPress(CURRENT_CLIENT(htt), event);
    return (0);
}
Static int
XimpKeyrelease(event)
    XEvent         *event;
{
    FXimp_ICID      icid = (FXimp_ICID) event->xclient.data.l[1];
    FXimp_Client    *ic = (FXimp_Client *)icid;
    int             keycode = event->xclient.data.l[2];
    int             state = event->xclient.data.l[3];
    Bool            bes = False;

    /*
     * $@$H$j$"$($:(J
     */
    
    if(!(ic->input_mask & KeyReleaseMask)) return 0;

    if( ((ic->style2 & XIMP_BACKEND ) == XIMP_BACKEND) &&
	((ic->style2 & XIMP_SYNC) == XIMP_SYNC) )
		bes = True;
    if( bes ||
	(
	  (ic->outgoing_keypress.keycode == keycode &&
           ic->outgoing_keypress.state == state)
	)
    ) 
    {
	XimpSendEvent(icid->focus_window,
		 XIMP_KEYRELEASE_RETURN4, icid, keycode, state, 0);
	if(bes && !ic->keypress_hold) {
		event->xkey.keycode = keycode;
		event->xkey.state   = state;
		XimpSendKeyrelease(event);
	}
    }
    return (0);
}
int
XimpSendKeyrelease(event)
    XKeyReleasedEvent         *event;
{
    FXimp_ICID      ic = CURRENT_CLIENT(htt);
    if(!(ic->input_mask & KeyReleaseMask)) return 0 ;
    if( 
	(
	  ((ic->style2 & XIMP_BACKEND ) == XIMP_BACKEND) && 
          ((ic->style2 & XIMP_SYNC) == XIMP_SYNC) 
 	) ||
	(
	  (ic->outgoing_keypress.keycode == event->keycode &&
           ic->outgoing_keypress.state == event->state)
	)
    ) 
    {
	XimpSendEvent(ic->focus_window,
		 XIMP_KEYRELEASE4, ic, event->keycode, event->state, 0);
    }
    return (0);
}
Static int
XimpEventmaskNotify(event)
    XClientMessageEvent         *event;
{
    FXimp_ICID      ic = CURRENT_CLIENT(htt);
    (CURRENT_CLIENT(htt))->input_mask = event->data.l[2];
    XimpSendEvent(ic->focus_window,
		      XIMP_EVENTMASK_NOTIFY_RETURN4, ic, NULL, NULL, 0);
}

Static int
XimpBegin(event)
    XEvent         *event;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    Ximp_StatusPropRec	*current_status;
    Window		 parent;
    long                 input_mask = KeyPressMask | StructureNotifyMask ;
    FXimp_Client	*this_ic = (FXimp_Client *)event->xclient.data.l[1];
    FXimp_Client	*save_ic = CURRENT_CLIENT(htt);

    CURRENT_CLIENT(htt) = this_ic;

    if ( ( CURRENT_CLIENT(htt)->style2 & XIMP_FE_TYPE1 ) == XIMP_FE_TYPE1 ) {
	if((CURRENT_CLIENT(htt))->input_mask & KeyReleaseMask)
	    input_mask |= KeyReleaseMask ;
	XSelectInput(display, CURRENT_CLIENT(htt)->focus_window, input_mask);
	CURRENT_CLIENT(htt)->frontend_key_press_mask = 1;
    }
    CURRENT_CLIENT(htt)->imp_mode |= FIMP_BEGIN;

    current_status = CURRENT_CLIENT(htt)->status;
    if (CURRENT_CLIENT(htt)->ext_ui_statuswindow && current_status->window) {
	parent = current_status->window;
	if (parent)
	    XReparentWindow(display, CURRENT_CLIENT(htt)->status_window,
		    parent, current_status->Area.x, current_status->Area.y);
    }
    Fj_ChangeMode(0, 0, 0, 0, FK_NIHONGO_ON);
    xsfIMLbegin(CURRENT_CLIENT(htt), event);
    if (!(CURRENT_CLIENT(htt)->style & (XIMPreeditCallbacks|XIMStatusCallbacks)))
	SetFocusClient();
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP ) {
	if ( ( CURRENT_CLIENT(htt)->style2 & XIMP_FRONTEND )
	   && ( CURRENT_CLIENT(htt)->style2 & ( XIMP_TYPE1 | XIMP_TYPE3 ) ) )
	    XimpSendEvent(CURRENT_CLIENT(htt)->focus_window,
		    XIMP_SPROC_STARTED, CURRENT_CLIENT(htt), 0, 0, 0);
    }
    CURRENT_CLIENT(htt) = save_ic;
    return (0);
}

int
XimpCnversionEnd(current_client)
    FXimp_Client   *current_client;
{
    Display        *display = GET_HTT_VALUE(htt, display);

    if( NumOfRemainConvOnIC(current_client) <= 1 )  { /* no other siblings are ON */
        if (  ( current_client->style2 & XIMP_TYPE1 )
           && ( current_client->frontend_key_press_mask ) ) {
	    current_client->frontend_key_press_mask = 0;
	    XSelectInput( display,
		current_client->focus_window, StructureNotifyMask );
        }
    }
    if        ( current_client->ximp_version == XIMP_PROTO_35_GRP ) {
        XimpSendEvent( current_client->focus_window,
		   XIMP_CONVERSION_END_BC, current_client, 0, 0, 0 );
    } else if ( current_client->ximp_version == XIMP_PROTO_40_GRP ) {
	if ( current_client->style2 & ( XIMP_TYPE1 | XIMP_TYPE3 ) )
	    XimpSendEvent( current_client->focus_window,
			XIMP_SPROC_STOPPED, current_client, 0, 0, 0 );
    }
    if ( current_client->preedit_window ) {
	UnmapPreeditWindow();
	UnmapCaretWindow(display, current_client);
    }
    current_client->imp_mode &= ~FIMP_BEGIN;
    return (0);
}
int
XimpProcessStart(current_client)
FXimp_Client *current_client ;
{
    Display        *display = GET_HTT_VALUE(htt, display);

    Ximp_StatusPropRec	*current_status;
    Window		 parent;
    long                 input_mask = KeyPressMask | StructureNotifyMask ;

    if ( ( current_client->style2 & XIMP_FE_TYPE1 ) == XIMP_FE_TYPE1 ) {
	if((CURRENT_CLIENT(htt))->input_mask & KeyReleaseMask)
	    input_mask |= KeyReleaseMask ;
	XSelectInput(display, current_client->focus_window,
		     input_mask);
	current_client->frontend_key_press_mask = 1;
    }
    current_client->imp_mode |= FIMP_BEGIN;

    current_status = current_client->status;
    if (current_client->ext_ui_statuswindow && current_status->window) {
	parent = current_status->window;
	if (parent)
	    XReparentWindow(display, current_client->status_window,
		    parent, current_status->Area.x, current_status->Area.y);
    }
    Fj_ChangeMode(0, 0, 0, 0, FK_NIHONGO_ON);
#ifdef notdef
    if (!(current_client->style & (XIMPreeditCallbacks|XIMStatusCallbacks)))
	SetFocusClient();
#endif
    if ( current_client->ximp_version == XIMP_PROTO_40_GRP ) {
	if ( ( current_client->style2 & XIMP_FRONTEND )
	   && ( current_client->style2 & ( XIMP_TYPE1 | XIMP_TYPE3 ) ) )
	    XimpSendEvent(current_client->focus_window,
		    XIMP_SPROC_STARTED, current_client, 0, 0, 0);
    }
    if(
	(current_client->style & XIMPreeditPosition) ||
	(current_client->style & XIMPreeditArea) ||
	(current_client->style & XIMPreeditNothing)
    )
	DisplayCursor(current_client, False);
    return (0);
}
Static int
XimpEnd(event)
    XEvent         *event;
{
    Display        *display = GET_HTT_VALUE(htt, display);

    UnsetFocusClient();

    if (CURRENT_CLIENT(htt)->frontend_key_press_mask) {
	CURRENT_CLIENT(htt)->frontend_key_press_mask = 0;
	XSelectInput(display, CURRENT_CLIENT(htt)->focus_window, StructureNotifyMask);
    }
    CURRENT_CLIENT(htt)->imp_mode &= ~FIMP_BEGIN;
    Fj_ChangeMode(0, 0, 0, 0, FK_NIHONGO_OFF);
    return (0);
}

Static int
XimpSetfocus(event)
    XEvent         *event;
{
    CURRENT_CLIENT(htt)->imp_mode |= FIMP_SETFOCUS;

    SetFocusClient() ;

    return (0);
}

Static int
XimpUnsetfocus(event)
    XEvent         *event;
{
    CURRENT_CLIENT(htt)->imp_mode &= ~FIMP_SETFOCUS;

    UnsetFocusClient() ;
    xsfIMLunsetfocus(CURRENT_CLIENT(htt));
    return (0);
}

Static int
XimpMove(event)
    XEvent         *event;
{
    int             x = event->xclient.data.l[2], y = event->xclient.data.l[3];
    FXimp_Client *focus_in_client=GET_HTT_VALUE(htt,focus_in_client);
    int mode;
    int preedit_feedback=GET_HTT_VALUE(htt,preedit_feedback);

    if (CURRENT_CLIENT(htt) != focus_in_client)
        return(0);

    if (preedit_feedback == FEEDBACK_STIPPLE) {
        if (CURRENT_CLIENT(htt) == focus_in_client)
           mode = highlight;
        else
           mode = stipple;
    }
    else
        mode = highlight;

    if (x < 0)
	x = 0;
    if (y < 0)
	y = CURRENT_CLIENT(htt)->preedit_font->max_font_ascent;

    if (CURRENT_CLIENT(htt)->style & XIMPreeditPosition) {
	CURRENT_CLIENT(htt)->preedit->SpotLocation.x = x;
	CURRENT_CLIENT(htt)->preedit->SpotLocation.y = y;
	CURRENT_CLIENT(htt)->input_flag = FINF_MODY;
	if (CURRENT_CLIENT(htt)->henkan_mode) {
	    DisplayOutputBuff(CURRENT_CLIENT(htt), mode, False);
	    DisplayCursor(CURRENT_CLIENT(htt), False);
	}
    }
    return (0);
}

Static int
XimpSetvalue(event)
    XEvent         *event;
{
    Display        *display = GET_HTT_VALUE(htt, display);

    unsigned long   mask = event->xclient.data.l[2];
    Window          window;
    int             rc;
    long            event_mask;
    Ximp_PreeditPropRec preedit;
    Ximp_StatusPropRec status;
    preedit = *CURRENT_CLIENT(htt)->preedit;
    status = *CURRENT_CLIENT(htt)->status;
    window = CURRENT_CLIENT(htt)->window;
    if (  (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP )
	  && ( mask & XIMP_FOCUS_WIN_MASK_BC ) )
       || (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP )
	  && ( mask & XIMP_FOCUS_WIN_MASK ) ) ) {
	Window         *focus_window;
	focus_window = (Window *) GetXimpSubProperty(window, IMA_FOCUS, XA_WINDOW);
	if (!focus_window) {
	    ErrorMessage(108, _XIMP_FOCUS);
	    XimpSendErrorEvent(CURRENT_CLIENT(htt)->focus_window,
			  icid, event->xclient.serial, XIMP_BadProperty, 0);
	    return (-1);
	}
	XSelectInput(display, CURRENT_CLIENT(htt)->focus_window, NoEventMask);
	CURRENT_CLIENT(htt)->frontend_key_press_mask = 0;
	if (CURRENT_CLIENT(htt)->style & XIMPreeditPosition) {
	    Htt_PreeditWinRec  *winfo = CURRENT_CLIENT(htt)->preedit_window_info;
	    for ( ; winfo; winfo = winfo->next_link ) {
	    	if ( winfo->status & PREEDITWIN_ROOT )
		    continue;
		XReparentWindow( display, winfo->win_part, *focus_window,
				    winfo->area_part.x, winfo->area_part.y );
	    }
	}
	CURRENT_CLIENT(htt)->focus_window = *focus_window;
	if ( CURRENT_CLIENT(htt)->style2 & XIMP_FRONTEND ) {
	    if ( ( CURRENT_CLIENT(htt)->style2 & ( XIMP_TYPE2 | XIMP_TYPE3 ) ) ||
		 ( ( CURRENT_CLIENT(htt)->style2 & XIMP_TYPE1 ) &&
		   ( CURRENT_CLIENT(htt)->henkan_mode ) ) ) {
		event_mask = KeyPressMask | StructureNotifyMask;
		CURRENT_CLIENT(htt)->frontend_key_press_mask = 1;
	    }
	} else
	    event_mask = StructureNotifyMask;
	XSelectInput(display, CURRENT_CLIENT(htt)->focus_window, event_mask);
    }
    if (  (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP )
	  && ( mask & XSF_PRE_MASK_BC ) )
       || (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP )
	  && ( mask & XSF_PRE_MASK ) ) ) {
	if ( CURRENT_CLIENT(htt)->style
	    & ( XIMPreeditPosition | XIMPreeditNothing | XIMPreeditArea ) ) {
	    rc = GetPreeditPropRec(window, &preedit, mask);
	    if (rc) {
		GetPropErrorSendEvent(rc, CURRENT_CLIENT(htt)->focus_window,
				      icid, event->xclient.serial);
		return (-1);
	    }
	    ChangePreeditWindow(&preedit);
	}
    }
    if (  (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP )
	  && ( mask & XSF_STS_MASK_BC ) )
       || (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP )
	  && ( mask & XSF_STS_MASK ) ) ) {
	if (CURRENT_CLIENT(htt)->style & (XIMStatusArea | XIMStatusNothing)) {
	    rc = GetStatusPropRec(window, &status, mask);
	    if (rc) {
		GetPropErrorSendEvent(rc, CURRENT_CLIENT(htt)->focus_window,
				      icid, event->xclient.serial);
		return (-1);
	    }
	    ChangeStatusWindow(&status);
	}
    }
    if (  (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP )
          && ( mask & XIMP_PRE_FONT_MASK_BC ) )
       || (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP )
          && ( mask & XIMP_PRE_FONT_MASK ) ) ) {
	if (CURRENT_CLIENT(htt)->style & (XIMPreeditPosition | XIMPreeditNothing)) {
	    CURRENT_CLIENT(htt)->preedit_fontname =
		GetXimpSubProperty(window, IMA_PREEDITFONT, XA_STRING);
	    ChangePreeditFont();
	}
    }
    if (  (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP )
          && ( mask & XIMP_STS_FONT_MASK_BC ) )
       || (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP )
          && ( mask & XIMP_STS_FONT_MASK ) ) ) {
	if (CURRENT_CLIENT(htt)->style & (XIMStatusArea | XIMStatusNothing)) {
	    CURRENT_CLIENT(htt)->status_fontname =
		GetXimpSubProperty(window, IMA_STATUSFONT, XA_STRING);
	    ChangeStatusFont();
	}
    }
    ChangeWindows( CURRENT_CLIENT(htt), &preedit, &status );
    return (0);
}

Static int
XimpGetvalue(event)
    XEvent         *event;
{
    Display        *display = GET_HTT_VALUE(htt, display);

    unsigned long   mask = event->xclient.data.l[2];
    Window          window;
    int             rc;
    long            event_mask;
    FXimp_Client   *this_ic = (FXimp_Client *)event->xclient.data.l[1];
    FXimp_Client   *save_ic = CURRENT_CLIENT(htt);

    CURRENT_CLIENT(htt) = this_ic;

    window = CURRENT_CLIENT(htt)->window;

    if (  (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP )
	  && ( mask & XIMP_FOCUS_WIN_MASK_BC ) )
       || (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP )
	  && ( mask & XIMP_FOCUS_WIN_MASK ) ) ) {
	SetXimpSubProperty(window, IMA_FOCUS, XA_WINDOW, 32,
			   &CURRENT_CLIENT(htt)->focus_window, 1);
    }
    if (  (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP )
	  && ( mask & XSF_PRE_MASK_BC ) )
       || (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP )
	  && ( mask & XSF_PRE_MASK ) ) ) {
	Ximp_PreeditPropRec preedit;
	bzero(&preedit, sizeof(Ximp_PreeditPropRec));
	SetPreeditPropRec(&preedit, CURRENT_CLIENT(htt)->preedit, mask);
	SetXimpSubProperty(window, IMA_PREEDIT, IMA_PREEDIT, 32,
			   &preedit, sizeof(Ximp_PreeditPropRec) / 4);
    }
    if (  (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP )
	  && ( mask & XSF_STS_MASK_BC ) )
       || (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP )
	  && ( mask & XSF_STS_MASK ) ) ) {
	Ximp_StatusPropRec status;
	bzero(&status, sizeof(Ximp_StatusPropRec));
	SetStatusPropRec(&status, CURRENT_CLIENT(htt)->status, mask);
	SetXimpSubProperty(window, IMA_STATUS, IMA_STATUS, 32,
			   &status, sizeof(Ximp_StatusPropRec) / 4);
    }
    if (  (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP )
          && ( mask & XIMP_PRE_FONT_MASK_BC ) )
       || (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP )
          && ( mask & XIMP_PRE_FONT_MASK ) ) ) {
	if (CURRENT_CLIENT(htt)->style & (XIMPreeditPosition | XIMPreeditNothing)) {
	    SetXimpSubProperty(window, IMA_PREEDITFONT, XA_STRING, 8,
			       CURRENT_CLIENT(htt)->preedit_fontname,
			       strlen(CURRENT_CLIENT(htt)->preedit_fontname));
	}
    }
    if (  (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP )
          && ( mask & XIMP_STS_FONT_MASK_BC ) )
       || (  ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP )
          && ( mask & XIMP_STS_FONT_MASK ) ) ) {
	if (CURRENT_CLIENT(htt)->style & (XIMStatusArea | XIMStatusNothing)) {
	    SetXimpSubProperty(window, IMA_STATUSFONT, XA_STRING, 8,
			       CURRENT_CLIENT(htt)->status_fontname,
			       strlen(CURRENT_CLIENT(htt)->status_fontname));
	}
    }
    if ( mask & XIMP_SERVERTYPE_MASK )
	SetXimpSubProperty( window, IMA_TYPE, IMA_TYPE, 32,
			   &CURRENT_CLIENT(htt)->style2, 1 );
    XFlush(display);
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	XimpSendEvent(CURRENT_CLIENT(htt)->focus_window,
		  XIMP_GETVALUE_RETURN_BC, CURRENT_CLIENT(htt), 0, 0, 0);
    } else {
	XimpSendEvent(CURRENT_CLIENT(htt)->focus_window,
		  XIMP_GETVALUE_RETURN, CURRENT_CLIENT(htt), 0, 0, 0);
    }

    CURRENT_CLIENT(htt) = save_ic;
    return (0);
}

Static int
SetXimpSubProperty(window, atomid, type, format, data, nelements)
    Window          window;
    Atom            atomid, type;
    int             format, nelements;
    unsigned char  *data;
{
    Display        *display = GET_HTT_VALUE(htt, display);
    
    Atom            actual_type_ret;
    int             actual_format_ret;
    unsigned long   nitems_ret;
    unsigned long   bytes_after_ret;
    unsigned char  *win_data;
    int             j;
    for (j = XIMP_TIME_OUT; j > 0; j--) {
	XGetWindowProperty(display, window, atomid, 0L, 8192L,
	     False, type, &actual_type_ret, &actual_format_ret, &nitems_ret,
			   &bytes_after_ret, &win_data);
	if (actual_format_ret == 0 || nitems_ret == 0) {
	    XChangeProperty(display, window, atomid, type, format,
			    PropModeAppend, data, nelements);
	    return (0);
	}
	XFree((char *) win_data);
	sleep(1);
    }
    return (-1);
}

Static int
XimpReset(event)
    XEvent         *event;
{
    xsfIMLreset(CURRENT_CLIENT(htt));
    return (0);
}

Static int
XimpExtension(event)
    XEvent         *event;
{
    Atom            atom = (Atom) event->xclient.data.l[2];
    int             data1 = event->xclient.data.l[3];
    int             data2 = event->xclient.data.l[4];
    FXimp_Client        *this_ic = (FXimp_Client *)event->xclient.data.l[1];
    FXimp_Client	*save_ic = CURRENT_CLIENT(htt);
    
    CURRENT_CLIENT(htt) = this_ic;

    if (atom == IMA_EXT_SAMPLE_BACK_FRONT) {
	CURRENT_CLIENT(htt)->ext_ui_back_front = data1;
	if ( CURRENT_CLIENT(htt)->ext_ui_back_front == 0 ) {
	    CURRENT_CLIENT(htt)->style2 =
			( CURRENT_CLIENT(htt)->style2 & ~XIMP_BACKEND ) | XIMP_FRONTEND;
	} else {
	    CURRENT_CLIENT(htt)->style2 =
			( CURRENT_CLIENT(htt)->style2 & ~XIMP_FRONTEND ) | XIMP_BACKEND;
	}
    } else if (atom == IMA_EXT_SAMPLE_STATUSWINDOW) {
	if ((CURRENT_CLIENT(htt)->imp_mode & FIMP_BEGIN) != 0) {
	    CURRENT_CLIENT(htt)->ext_ui_statuswindow = 1;
	}
    } else if (atom == IMA_EXT_XIMP_CONVERSION) {
	if ( !data1 ) {
	    event->xclient.data.l[4] = (long)(CURRENT_CLIENT(htt)->iml_status &
					IMLSTATUS_Henkan_Mode);
	    XimpSendEvent2( CURRENT_CLIENT(htt), event, 32 );
	} else {
	    /* set */
	    iml_inst *rv ;
	    iml_status_t status = data2 ;
	    FXimp_Client *ic = FindClientByICID(icid);

	    if_SetSCValue(ic->s, XNExtXimp_Conversion, status);
	}

    }
    CURRENT_CLIENT(htt) = save_ic;
    return (0);
}

/* 91/07/19  Preedit_Start_Return  */
static int
XimpPreeditStartRet(event)
    XEvent         *event;
{
    int             data = event->xclient.data.l[2];

    xsfIMLpreeditstartret(CURRENT_CLIENT(htt), event, data);

    return (0);
}

/* 91/07/19  Preedit_Caret_Return  */
static int
XimpPreeditCaretRet(event)
    XEvent         *event;
{
    int             data = event->xclient.data.l[2];

    xsfIMLpreeditcaretret(CURRENT_CLIENT(htt), event, data);

    return (0);
}

static void
Ximp_send_compound_text(ic, ct, ctlen)
FXimp_Client    *ic;
char		*ct;
int		 ctlen;
{
    Display            *display = GET_HTT_VALUE(htt, display);
    int msglen = XSF_COMMIT_CMSG ;
    XEvent		event;
    Ximp_CommitPropRec *msg = (Ximp_CommitPropRec *) & event.xclient.data.l[0];

    while(ctlen > 0){
	bzero( &event, sizeof(event) );
	msg->icid = (long)ic;
	msg->size = ctlen;
	if(ctlen < XSF_COMMIT_CMSG){
	    msglen = ctlen ;
	}
	bcopy(ct, msg->ctext, msglen);
	XimpSendEvent2(ic, &event, 8);
	ctlen -= XSF_COMMIT_CMSG;
	ct += XSF_COMMIT_CMSG ;
    }
    XFlush( display );
    return;
}

static void
Ximp_preeditdraw_cm( ic, pds, compound_text, compound_length )
    FXimp_Client		    *ic;
    XIMPreeditDrawCallbackStruct    *pds;
    char			    *compound_text;
    int				     compound_length;
{
    XEvent	 event;
    XIMFeedback	*feedback;
    XIMFeedback	 first_feedback;
    wchar_t	*text;
    wchar_t	*conv_text;
    char	*conv_compound_text;
    int		 i;
    int		 chg_count;
    int		 size;
    int		 conv_compound_length;
    int		 chg_first = pds->chg_first;
    int		 chg_length = pds->chg_length;
    bzero( &event, sizeof(event) );
    if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_35_GRP ) {
	event.xclient.data.l[0] = XIMP_PREEDITDRAW_CM_BC;
    } else {
	event.xclient.data.l[0] = XIMP_PREEDITDRAW_CM;
    }
    event.xclient.data.l[1] = (unsigned long)ic;
    event.xclient.data.l[2] = pds->caret;
    if ( ( !pds->text )
      || ( ( !pds->text->feedback )
	&& ( !pds->text->string.wide_char ) ) ) {
	event.xclient.data.l[2] |=
		( XIMP_PDCBSTATUS_NOTEXT | XIMP_PDCBSTATUS_NOFEEDBACK ) << 16;
	event.xclient.data.l[3]  = chg_length;
	event.xclient.data.l[3] |= chg_first << 16;
	event.xclient.data.l[4]  = 0;
    } else if ( !pds->text->feedback ) {
#ifdef USE_PREEDITDRAW_TINY
#define	PREEDITDRAW_TINY_SIZE	8
	if ( pds->text->length < PREEDITDRAW_TINY_SIZE ) {
	    Ximp_preeditdraw_tiny( ic, pds, compound_text, compound_length );
	    return;
	}
#endif					/* USE_PREEDITDRAW_TINY */
	event.xclient.data.l[2] |= XIMP_PDCBSTATUS_NOFEEDBACK << 16;
	event.xclient.data.l[3]  = chg_length;
	event.xclient.data.l[3] |= chg_first << 16;
	event.xclient.data.l[4]  = 0;
    } else if ( !pds->text->string.wide_char ) {
#ifdef USE_PREEDITDRAW_FEEDBACK
	chg_count = 0;
	first_feedback = *pds->text->feedback;
	for ( i = 0, feedback = pds->text->feedback;
			i < pds->text->length; i++, feedback++ ) {
	    if ( first_feedback != *feedback ) {
		chg_count++;
		first_feedback = *feedback;
	    }
	}
#endif					/* USE_PREEDITDRAW_FEEDBACK */
	if ( CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP ) {
#ifdef USE_PREEDITDRAW_FEEDBACK
	    if ( chg_count < 2 ) {
		Ximp_preeditdraw_feedback( ic, pds );
		return;
	    } else {
#endif					/* USE_PREEDITDRAW_FEEDBACK */
		event.xclient.data.l[2] |=
		    ( XIMP_PDCBSTATUS_FEEDBACKS_VIA_PROP
				| XIMP_PDCBSTATUS_NOTEXT ) << 16;
		event.xclient.data.l[3]  = chg_length;
		event.xclient.data.l[3] |= chg_first << 16;
		event.xclient.data.l[4]  =
			XimpReplacePropPool(ic, 
				IMA_FEEDBACKS, (char *) pds->text->feedback,
				pds->text->length, 32);
#ifdef USE_PREEDITDRAW_FEEDBACK
	    }
#endif					/* USE_PREEDITDRAW_FEEDBACK */
	} else {
	    event.xclient.data.l[2] |= XIMP_PDCBSTATUS_NOTEXT << 16;
            event.xclient.data.l[3]  = chg_length;
            event.xclient.data.l[3] |= chg_first << 16;
            event.xclient.data.l[4]  = *pds->text->feedback;
        }
    } else {
	chg_count = 0;
	first_feedback = *pds->text->feedback;
	for ( i = 0, feedback = pds->text->feedback;
			i < (int)pds->text->length; i++, feedback++ ) {
	    if ( first_feedback != *feedback ) {
		chg_count++;
		first_feedback = *feedback;
	    }
	}
	if ( chg_count == 0 ) {
	    event.xclient.data.l[3]  = chg_length;
	    event.xclient.data.l[3] |= chg_first << 16;
	    event.xclient.data.l[4]  = *pds->text->feedback;
	} else if ( ic->ximp_version == XIMP_PROTO_40_GRP ) {
	    event.xclient.data.l[2] |=
			XIMP_PDCBSTATUS_FEEDBACKS_VIA_PROP << 16;
	    event.xclient.data.l[3]  = chg_length;
	    event.xclient.data.l[3] |= chg_first << 16;
	    event.xclient.data.l[4]  =
		    XimpReplacePropPool(ic, IMA_FEEDBACKS,
			(char *) pds->text->feedback, pds->text->length, 32);
	} else {
	    int		first_chg_first = chg_first;
	    first_feedback = *pds->text->feedback;
	    Xsf_XIMTextToWcs( pds->text, &text );
	    conv_text = text;
	    size = 0;
	    for ( i = 0, feedback = pds->text->feedback;
			i < (int)pds->text->length;
			i++, size++, feedback++, chg_first++ ) {
		if ( first_feedback != *feedback ) {
		    event.xclient.data.l[3]  = chg_length;
		    event.xclient.data.l[3] |= first_chg_first << 16;
		    event.xclient.data.l[4]  = first_feedback;
		    first_chg_first = chg_first;
		    first_feedback = *feedback;
		    XimpSendEvent2( ic, &event, 32 );
		    conv_compound_text = (char *)malloc( ( size + 1 ) * 5 );
		    conv_compound_length = EUC_To_CompoundText(
					conv_compound_text, conv_text, size );
		    Ximp_send_compound_text( ic,
				conv_compound_text, conv_compound_length );
		    free( conv_compound_text );
		    chg_length = 0;
		    conv_text += size;
		    size = 0;
		}
	    }
	    event.xclient.data.l[3]  = chg_length;
	    event.xclient.data.l[3] |= first_chg_first << 16;
	    event.xclient.data.l[4]  = first_feedback;
	    first_feedback = *feedback;
	    XimpSendEvent2( ic, &event, 32 );
	    conv_compound_text = (char *)malloc( ( size + 1 ) * 5 );
	    conv_compound_length = EUC_To_CompoundText(
				conv_compound_text, conv_text, size );
	    Ximp_send_compound_text( ic,
			conv_compound_text, conv_compound_length );
	    free( conv_compound_text );
	    free( text );
	    return;
	}
    }
    XimpSendEvent2( ic, &event, 32 );
    Ximp_send_compound_text( ic, compound_text, compound_length );
    return;
}

#ifdef USE_PREEDITDRAW_TINY
static void
Ximp_preeditdraw_tiny( ic, pds, compound_text, compound_length )
    FXimp_Client		    *ic;
    XIMPreeditDrawCallbackStruct    *pds;
    char			    *compound_text;
    int				     compound_length;
{
    Display     *display = GET_HTT_VALUE(htt, display);
    XEvent	event;
    char	*text = (char *)&event.xclient.data.l[3];

    bzero( &event, sizeof(event) );
    event.xclient.data.l[0]  = XIMP_PREEDITDRAW_CM_TINY;
    event.xclient.data.l[1]  = (unsigned long)ic;
    event.xclient.data.l[2]  = compound_length;
    event.xclient.data.l[2] |= pds->chg_length << 8;
    event.xclient.data.l[2] |= pds->chg_first << 16;
    bcopy( compound_text, text, compound_length );
    XimpSendEvent2( ic, &event, 32 );
    XFlush( display );
    return;
}
#endif					/* USE_PREEDITDRAW_TINY */

#ifdef USE_PREEDITDRAW_FEEDBACK
static void
Ximp_preeditdraw_feedback( ic, pds )
    FXimp_Client		    *ic;
    XIMPreeditDrawCallbackStruct    *pds;
{
    Display     *display = GET_HTT_VALUE(htt, display);
    XEvent	 event;
    int		 count;
    int		 chg_first  = pds->chg_first;
    int		 length     = pds->text->length;
    XIMFeedback	*feedback   = pds->text->feedback;
    XIMFeedback	 first_feedback;

    bzero( &event, sizeof(event) );
    first_feedback = *feedback;
    event.xclient.data.l[0] = XIMP_PREEDITDRAW_CM_FEEDBACK;
    event.xclient.data.l[1] = (unsigned long)ic;
    event.xclient.data.l[2] = chg_first << 24;
    event.xclient.data.l[3] = (unsigned long)first_feedback;
    for ( count = 0;
	( ( count < length ) && ( *feedback == first_feedback ) );
					count++, chg_first++, feedback++ );
    event.xclient.data.l[2] |= count << 16;
    if ( count < length ) {
	event.xclient.data.l[2] |= chg_first << 8;
	event.xclient.data.l[2] |= length - count;
	event.xclient.data.l[4] = (unsigned long)*feedback;
    } else {
	event.xclient.data.l[2] |= 0xffff;
    }
    XimpSendEvent2( ic, &event, 32 );
    XFlush( display );
    return;
}
#endif					/* USE_PREEDITDRAW_FEEDBACK */

extern void
Ximp_Send_Keypress_Return( ic , rec_ev )
    FXimp_Client	*ic;
    XEvent		*rec_ev;
{
    Display     *display = GET_HTT_VALUE(htt, display);
    XEvent	 event;

    if ( ( ( ic->style2 & XIMP_BACKEND ) == XIMP_BACKEND ) &&
	 ( ( ic->style2 & XIMP_SYNC ) == XIMP_SYNC ) ) {
	event.xclient.data.l[0] = XIMP_KEYPRESS_RETURN;
	event.xclient.data.l[1] = (unsigned long)ic;
	XimpSendEvent2( ic, &event, 32 );
        ic->outgoing_keypress.keycode = rec_ev->xkey.keycode;
        ic->outgoing_keypress.state = rec_ev->xkey.state;
	XFlush( display );
    }
    return;
}

Static int
XimpClientWindow(event)
    XEvent         *event;
{
    Display     *display = GET_HTT_VALUE(htt, display);
    int			 rc;
    long		 event_mask;
    Window		 new_window = event->xclient.data.l[2];
    Window		 old_window = CURRENT_CLIENT(htt)->window;
    Ximp_PreeditPropRec	*preedit = CURRENT_CLIENT(htt)->preedit;
    Ximp_StatusPropRec	*status = CURRENT_CLIENT(htt)->status;
    FXimp_Client        *this_ic = (FXimp_Client *)event->xclient.data.l[1];
    FXimp_Client	*save_ic = CURRENT_CLIENT(htt);
    
    CURRENT_CLIENT(htt) = this_ic;

    if (!new_window) {
	ErrorMessage(108, _XIMP_FOCUS);
	XimpSendErrorEvent(CURRENT_CLIENT(htt)->focus_window,
			  icid, event->xclient.serial, XIMP_BadClientWindow, 0);
	CURRENT_CLIENT(htt) = save_ic;
	return (-1);
    }
    if (CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP ) {
	if(event->xclient.data.l[3])
	   CURRENT_CLIENT(htt)->input_mask = event->xclient.data.l[3];
    }

    if ( CURRENT_CLIENT(htt)->style & XIMPreeditArea ) {
	    Htt_PreeditWinRec  *winfo = CURRENT_CLIENT(htt)->preedit_window_info;
	for ( ; winfo; winfo = winfo->next_link ) {
	    if ( winfo->status & PREEDITWIN_ROOT )
		continue;
	    XReparentWindow( display, winfo->win_part, new_window,
				    winfo->area_part.x, winfo->area_part.y );
	}
	MapPreeditWindow();
    }
    if ( CURRENT_CLIENT(htt)->style & XIMStatusArea ) {
	if ( !CURRENT_CLIENT(htt)->ext_ui_statuswindow ) {
	    XReparentWindow( display, CURRENT_CLIENT(htt)->status_window, new_window,
		status->Area.x, status->Area.y );
	    MapStatusWindow( CURRENT_CLIENT(htt) );
	}
    }
    CURRENT_CLIENT(htt)->window = new_window;

    event->xclient.data.l[0] = XIMP_CLIENT_WINDOW_RETURN;
    event->xclient.data.l[1] = (unsigned long)CURRENT_CLIENT(htt);
    XimpSendEvent2( CURRENT_CLIENT(htt), event, 32 );
    XFlush( display );
    CURRENT_CLIENT(htt) = save_ic;
    return (0);
}

Static int
XimpFocusWindow(event)
    XEvent         *event;
{
    Display     *display = GET_HTT_VALUE(htt, display);
    int			 rc;
    long		 event_mask = 0L;
    Window		 focus_window = event->xclient.data.l[2];
    Window		 window = CURRENT_CLIENT(htt)->window;
    Ximp_PreeditPropRec	*preedit = CURRENT_CLIENT(htt)->preedit;
    Ximp_StatusPropRec	*status = CURRENT_CLIENT(htt)->status;
    FXimp_Client        *this_ic = (FXimp_Client *)event->xclient.data.l[1];
    FXimp_Client	*save_ic = CURRENT_CLIENT(htt);
    
    CURRENT_CLIENT(htt) = this_ic;

    if (!focus_window) {
	ErrorMessage(108, _XIMP_FOCUS);
	XimpSendErrorEvent(CURRENT_CLIENT(htt)->focus_window,
			  icid, event->xclient.serial, XIMP_BadFocusWindow, 0);
	CURRENT_CLIENT(htt) = save_ic;
	return (-1);
    }
    XSelectInput(display, CURRENT_CLIENT(htt)->focus_window, NoEventMask);
    CURRENT_CLIENT(htt)->frontend_key_press_mask = 0;
    if (CURRENT_CLIENT(htt)->style & XIMPreeditPosition) {
	    Htt_PreeditWinRec  *winfo = CURRENT_CLIENT(htt)->preedit_window_info;
	for ( ; winfo; winfo = winfo->next_link ) {
	    if ( winfo->status & PREEDITWIN_ROOT )
		continue;
	    XReparentWindow( display, winfo->win_part, focus_window,
				    winfo->area_part.x, winfo->area_part.y );
	    MapPreeditWindow();
	}
    }
    if (CURRENT_CLIENT(htt)->ximp_version == XIMP_PROTO_40_GRP ) {
	if(event->xclient.data.l[3])
	   CURRENT_CLIENT(htt)->input_mask = event->xclient.data.l[3];
    }
    if ( CURRENT_CLIENT(htt)->style2 & XIMP_FRONTEND ) {
	if ( ( CURRENT_CLIENT(htt)->style2 & ( XIMP_TYPE2 | XIMP_TYPE3 ) ) ||
	     ( ( CURRENT_CLIENT(htt)->style2 & XIMP_TYPE1 ) &&
	       ( CURRENT_CLIENT(htt)->henkan_mode ) ) ) {
	    event_mask = KeyPressMask | StructureNotifyMask;
	    if((CURRENT_CLIENT(htt))->input_mask & KeyReleaseMask)
		event_mask |= KeyReleaseMask ;
	    CURRENT_CLIENT(htt)->frontend_key_press_mask = 1;
	}
    } else
	event_mask = StructureNotifyMask;

    if(event_mask)
    	XSelectInput(display, focus_window, event_mask);

    event->xclient.data.l[0] = XIMP_FOCUS_WINDOW_RETURN;
    event->xclient.data.l[1] = (unsigned long)CURRENT_CLIENT(htt);
    XimpSendEvent2( CURRENT_CLIENT(htt), event, 32 );
    XFlush( display );

    DeleteFocusWindow( CURRENT_CLIENT(htt) );
    CURRENT_CLIENT(htt)->focus_window = focus_window;
    EntryFocusWindow( CURRENT_CLIENT(htt), focus_window );
    XUnmapWindow(display, CURRENT_CLIENT(htt)->preedit_window);
    if(!(CURRENT_CLIENT(htt)->style & XIMPreeditCallbacks))
	HttCaretWindowReparent(display, CURRENT_CLIENT(htt), focus_window);
    
    if ( CURRENT_CLIENT(htt)->style
	& ( XIMPreeditPosition | XIMPreeditNothing | XIMPreeditArea ) ) {
    	if(!CURRENT_CLIENT(htt)->xnarea_set) {
		SetDefaultPreeditXNArea(CURRENT_CLIENT(htt), preedit);
		ResizePreeditArea(CURRENT_CLIENT(htt));
	}
    }
    if ((CURRENT_CLIENT(htt)->style & XIMPreeditPosition) ||
	(CURRENT_CLIENT(htt)->style & XIMPreeditArea) ) {
	Htt_PreeditWinRec  *winfo = CURRENT_CLIENT(htt)->preedit_window_info;
	for ( ; winfo; winfo = winfo->next_link ) {
	   if ( winfo->status & PREEDITWIN_ROOT )
		continue;
	   XReparentWindow( display, winfo->win_part, focus_window,
				    winfo->area_part.x, winfo->area_part.y );
	   MapPreeditWindow();
	}
    }
    CURRENT_CLIENT(htt) = save_ic;
    return (0);
}

ConsolidateLucIF(ic, layout)
    FXimp_Client	*ic;
    LayoutInfo		*layout;
{
    LookupInfo *lucinfo = (LookupInfo *)GET_HTT_VALUE(htt, lookup_info);

    if(lucinfo->style == LOOKUP_MENU_IMSWINDOW) {
	if_SetSCValue(ic->s, SC_lookup_root,  True);
        if_SetSCValue(ic->s, SC_lookup_rootwidth, layout->root_width);
        if_SetSCValue(ic->s, SC_lookup_lines, layout->root_lines);
        if_SetSCValue(ic->s, SC_lookup_ewidth, layout->e_width_per_can);
        if_SetSCValue(ic->s, SC_lookup_cwidth, layout->max_width_per_car);
    }
    else
	if_SetSCValue(ic->s, SC_lookup_root,  False);
   
    if_SetSCValue(ic->s, SC_lookup_nchoices, layout->choice_per_window);
    if_SetSCValue(ic->s, SC_lookup_ncols, layout->ncolumns);
    if_SetSCValue(ic->s, SC_lookup_nrows, layout->nrows);
    if_SetSCValue(ic->s, SC_lookup_direction, layout->DrawUpDirection);
    if_SetSCValue(ic->s, SC_lookup_labeltype, layout->label_type);
    if_SetSCValue(ic->s, SC_lookup_whoownslabel, layout->WhoOwnsLabel);

    if_SetSCValue(ic->s, SC_nego_flush, True);
}   
